	SUBROUTINE SCORENY(IPAN)
****************************************************************
*  Subroutine finds ENY for semicore states                    *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	DIMENSION VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,R(0:NRADMAX,NSORTMAX),H(NSORTMAX),APHI(0:NRADMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),APHID(0:NRADMAX)
     &   ,SMT(NSORTMAX)
	COMPLEX*16EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG          !!! from coreny
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from readini
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
C  FIND BINDING ENERGIES FOR SEMICORE STATES
	IF(IPAN.EQ.1)RETURN
	DO 2000 ISPIN=1,NSPIN                                !!! over ispin
	ENY0=0.D0
	SATOM=0.D0
	DO 1000 ISORT=1,NSORT                                !!! over isort
	IF(ISTS(ISORT,IPAN).EQ.0)GOTO1000
	SATOM=SATOM+NHSORT(ISORT)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
        IF(MNY(L,ISORT,IKAP,IPAN).EQ.1.OR.
     &  MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C  TRANSFERE TO CONVINIET FUNCTION TNY DEPENDING ON DNY AND # OF NODES
        TNY(L,ISORT,IKAP,IPAN,ISPIN)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-
     &  ATAN(DNY(L,ISORT,IKAP,IPAN,ISPIN))/PI
C  FIND ENY-ENERGY
        CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  TNY(L,ISORT,IKAP,IPAN,ISPIN),ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &  ISORT,L+1,ISPIN)
        ELSEIF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
C  FIND BINDING ENERGY E FOR GIVEN VALENCE STATE
        CALL ENYCOR(ENY(L,ISORT,IKAP,IPAN,ISPIN),NODES(L,
     &  ISORT,IKAP,IPAN),L,-1,DLOG,SMT(ISORT),VSPH(0,ISORT,
     &  ISPIN),APHI(0),APHID(0),NRAD(ISORT),H(ISORT),
     &  R(0,ISORT),DR(0,ISORT),LR(ISORT))
        DHLOG(L,ISORT,IKAP,IPAN,ISPIN)=DLOG
        ENDIF
	ENY0=ENY0+ENY(L,ISORT,IKAP,IPAN,ISPIN)*NHSORT(ISORT)
	ENDIF
	ENDDO
	ENDDO
1000	CONTINUE
	ENY0=ENY0/SATOM/NKAP(IPAN)
	DO IKAP=1,NKAP(IPAN)
	DO ISORT=1,NSORT
	DO L=0,ILST(ISORT)
	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)=ENY0
	ENDDO
	ENDDO
	ENDDO
2000	CONTINUE                                             !!! over spins
	END
