	SUBROUTINE DRUNGE(ENY,DENY,AFIS,AFIPS,AFIDS,AFIDPS,FPMN,
     &  DFIS,DFIPS,DFIDS,DFIDPS,DFPMN,S,Z,DV,LM,NRAD,H,R,DR,LR)
************************************************************
*   The calculation of induced potential parameters        *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION Z(0:NRADMAX),FI(0:NRADMAX,5),FID(0:NRADMAX,5)
     &   ,AFIS(0:LMAXT),AFIPS(0:LMAXT),AFIDS(0:LMAXT)
     &   ,AFIDPS(0:LMAXT),ENY(0:LMAXT),R(0:NRADMAX)
     &   ,DR(0:NRADMAX),AFIDDS(0:LMAXT),AFIDDPS(0:LMAXT)
     &   ,FIPR(0:NRADMAX),FPMN(0:LMAXT)
	COMPLEX*16DFIS(0:LMAXT),DFIPS(0:LMAXT),DFIDS(0:LMAXT)
     &   ,DFIDPS(0:LMAXT),DFPMN(0:LMAXT),DV(0:NRADMAX)
     &   ,DFI (0:NRADMAX,0:LMAXT),DFID (0:NRADMAX,0:LMAXT)
     &   ,DFIP(0:NRADMAX,0:LMAXT),DFIDP(0:NRADMAX,0:LMAXT)
     &   ,DELFI(0:NRADMAX,5),DELFID(0:NRADMAX,5),DENY(0:LMAXT)
     &   ,DFIDDS(0:LMAXT),DFIDDPS(0:LMAXT),CF,DEN,DELNY,CFSIM
     &   ,DVL(0:NRADMAX)
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
        DELNY=(0.D0,0.D0)
        SQPI4=SQRT(4.D0*PI)
        DO 10 IRAD=0,NRAD
        DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
  10    CONTINUE
	DO 50 L=0,LM
C  SOLVE RADIAL SCHROEDINGER EQUATION
        CALL RADSCH(ENY(L),S,Z,L,NODES,D,FI(0,3),FID(0,3),NRAD,
     &  H,R,DR,LR)
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
        CALL DRADSCH(ENY(L),DELNY,S,Z,L,DVL,NOD,DELFI(0,3),
     &  DELFID(0,3),FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
C  SET POTENTIAL PARAMETERS AT THE SPHERE BOUNDARY
        AFIS(L)=FI(NRAD,3)
        AFIDS(L)=FID(NRAD,3)
        AFIPS(L)=DREAL(DELFI(NRAD,3))
        AFIDPS(L)=DREAL(DELFID(NRAD,3)) ! can be redefined below
C       AFIDPS(L)=AFIPS(L)/AFIS(L)*(AFIDS(L)-1.D0/(S*S*AFIPS(L)))
        DO 20 IRAD=0,NRAD
        FIPR(IRAD)=DREAL(DELFI(IRAD,3))*R(IRAD)
  20    CONTINUE
        FPMN(L)=FSIM(FIPR(0),FIPR(0),NRAD,H,DR)
C  SOLVE STERNHEIMER EQUATION
	DO 30 N=1,5
	EN=ENY(L)+DEL*(N-3.D0)
	DEN=DENY(L)
	CALL RADSCH(EN,S,Z,L,NODE,D,FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
	CALL DRADSCH(EN,DEN,S,Z,L,DV,NODA,DELFI(0,N),DELFID(0,N),
     &  FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
	IF(N.EQ.3)NODES=NODE
	IF(N.EQ.3)NODAS=NODA
  30    CONTINUE
	I=NRAD
	DFIS(L)=DELFI(I,3)
	DFIDS(L)=DELFID(I,3)
C       DFIDPS(L)=(DELFID(I,1)-DELFID(I,5)+8.D0*(DELFID(I,4)-
C    &  DELFID(I,2)))/(12.D0*DEL)             !!! redefined below
	DO 40 I=0,NRAD
	DELFI(I,3)=((DELFI(I,1)-DELFI(I,5)+8.D0*(DELFI(I,4)-DELFI(I,2)))
     &  /(12.D0*DEL))*R(I)
  40    CONTINUE
	DFIPS(L)=DELFI(NRAD,3)/S
	DFIDPS(L)=DFIDS(L)*AFIPS(L)/AFIS(L)+AFIDS(L)*DFIPS(L)/AFIS(L)-
     &  AFIDS(L)*AFIPS(L)/AFIS(L)**2*DFIS(L)+DFIS(L)/S/S/AFIS(L)**2
	DFPMN(L)=2.D0*CFSIM(FIPR(0),DELFI(0,3),NRAD,H,DR)
  50    CONTINUE
	RETURN



	ENTRY DSFIFID(ENY,DENY,DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,
     &                S,Z,DV,LM,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of change in radial functions       *
*********************************************************
	DO 80 L=0,LM
	DO 60 N=1,5
	EN=ENY(L)+DEL*(N-3.D0)
	DEN=DENY(L)
	CALL RADSCH(EN,S,Z,L,NODE,D,FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
	CALL DRADSCH(EN,DEN,S,Z,L,DV,NODA,DELFI(0,N),DELFID(0,N),
     &  FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
	IF(N.EQ.3)NODES=NODE
	IF(N.EQ.3)NODAS=NODA
  60    CONTINUE
	DO 70 I=0,NRAD
	DFI(I,L)=DELFI(I,3)
	DFID(I,L)=DELFID(I,3)
	DFIP(I,L)=(DELFI(I,1)-DELFI(I,5)+8.D0*(DELFI(I,4)-DELFI(I,2)))
     &  /(12.D0*DEL)
	DFIDP(I,L)=(DELFID(I,1)-DELFID(I,5)+8.D0*(DELFID(I,4)-
     &  DELFID(I,2)))/(12.D0*DEL)
  70    CONTINUE
C  SECOND ORDER DERIVATIVES AT THE SPHERE BOUNDARY
	DFIDDS(L)=DFI(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
     &           -2.D0/S*DFID(NRAD,L)!+...
	DFIDDPS(L)=DFIP(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
     &           -2.D0/S*DFIDP(NRAD,L)-DFI(NRAD,L)!+...
  80    CONTINUE
	RETURN
	END




	SUBROUTINE DRADSCH(EN,DEN,S,Z,L,DVL,NODES,DELFI,DELFID,FI,FID,
     &  NRAD,H,R,DR,LR)
***************************************************************
*  The solution of the linearized Schroedinger equation:      *
*   / dP'(r)=dQ(r)+(l+1)*dP(r)/r                              *
*   \ dQ'(r)=(V(r)-E)*dP(r)-(l+1)*dQ(r)/r+dV(r)*P(r)          *
*     dFI(r)=dP(r)/r and dFID(r)=dFI'(r)                      *
*  Written by S.Yu.Savrasov in Max-Planck-Institute, Germany  *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	IMPLICIT COMPLEX*16 (K,M)
	INCLUDE 'PARAM.DAT'
	REAL*8 L2
	DIMENSION Z(0:NRADMAX),R(0:NRADMAX),DR(0:NRADMAX)
     &    ,FI(0:NRADMAX),FID(0:NRADMAX),P(0:NRADMAX),Q(0:NRADMAX)
	COMPLEX*16DVL(0:NRADMAX),DELFI(0:NRADMAX),DELFID(0:NRADMAX)
     &   ,DP(0:NRADMAX),DQ(0:NRADMAX),DV(0:NRADMAX),DEN,CFSIM
     &   ,AL,BL,DV0,DV1,DV2,DV3,CF,DAN,DS1,DS2,DS3
	DATA C2/0.000013312838D0/,PI/3.141592657589793D0/
	SQPI4=SQRT(4.D0*PI)
C GET SPHERICAL PART OF THE INDUCED POTENTIAL
	DO 5 IRAD=0,NRAD
	DV(IRAD)=DVL(IRAD)/SQPI4-DEN
   5    CONTINUE
	L1=L+1
	NODES=0
	BETTA=S/(EXP(H*NRAD)-1.D0)
        IF(Z(0).GE.1.D-05)LCR=LR
        IF(Z(0).LE.1.D-05)LCR=0
C ****** NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE) ******
	IF(LCR.EQ.0) THEN
C   ASSYMPTOTIC BEHAVIOR ::
	I0=0
  10    I0=I0+1
	IF(I0.GT.NRAD)STOP'<DELRADSCH>:: I0.GT.NRAD' 
	IF(FI(I0).EQ.0.D0)GOTO10
	AN=FI(I0)/R(I0)**L/(1.D0-Z(0)/2.D0/(L+1)*R(I0))
	R1R2=R(1)/R(2)
	R2R1=R(2)/R(1)
	DV0=DV(0)
	DV1=(DV(1)-DV(0))/R(1)/(1.D0-R1R2)+(DV(2)-DV(0))/
     &  R(2)/(1.D0-R2R1)
	AL=AN*DV0/((L+2)*(L+3)-L*(L+1))
	BL=(AN*DV1-Z(0)/2.D0/(L+1)*AN*DV0-Z(0)*AL)/((L+3)*(L+4)-L*(L+1))
	I0=1
	P(0)=R(0)*FI(0)
	DP(0)=(0.D0,0.D0)
	DQ(0)=(0.D0,0.D0)
  20    DP(I0)=AL*R(I0)**(L+3)+BL*R(I0)**(L+4)
	P(I0)=R(I0)*FI(I0)
	IF(ABS(DP(I0)).EQ.0.D0)THEN
	DQ(I0)=0.D0
	I0=I0+1
	IF(I0.EQ.NRAD+1)GOTO40
	GOTO20
	ENDIF
	DQ(I0)=2.D0*AL*R(I0)**(L+2)+3.D0*BL*R(I0)**(L+3)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(I0)
	P3=R3*FI(I0)
	DV3=A3*DV(I0)
	DO 30 I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	V1=V3
	IF(I.NE.NRAD-1)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))
     &  *6.25D-2
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
	V3=A3*EN+A3/R3*Z(I+1)
	P1=P3
	IF(I.NE.NRAD-1)P2=R2*(9.D0*(FI(I)+FI(I+1))-FI(I-1)-FI(I+2))*
     &  6.25D-2
	IF(I.EQ.NRAD-1)P2=R2*(FI(I)+FI(I+1))*0.5D0
	P3=R3*FI(I+1)
	DV1=DV3
	IF(I.NE.NRAD-1)DV2=A2*(9.D0*(DV(I)+DV(I+1))-DV(I-1)-DV(I+2))*
     &  6.25D-2
	IF(I.EQ.NRAD-1)DV2=A2*(DV(I)+DV(I+1))*0.5D0
	DV3=A3*DV(I+1)
	P(I+1)=P3
C   **************
	K1= A1*DQ(I)+B1*DP(I)
	M1=-V1*DP(I)-B1*DQ(I)+DV1*P1
C   **************
	K2= A2*(DQ(I)+M1*0.5D0)+B2*(DP(I)+K1*0.5D0)
	M2=-V2*(DP(I)+K1*0.5D0)-B2*(DQ(I)+M1*0.5D0)+DV2*P2
C   **************
	K3= A2*(DQ(I)+M2*0.5D0)+B2*(DP(I)+K2*0.5D0)
	M3=-V2*(DP(I)+K2*0.5D0)-B2*(DQ(I)+M2*0.5D0)+DV2*P2
C   **************
	K4= A3*(DQ(I)+M3)+B3*(DP(I)+K3)
	M4=-V3*(DP(I)+K3)-B3*(DQ(I)+M3)+DV3*P3
C   **************
	DP(I+1)=DP(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	DQ(I+1)=DQ(I)+(M1+M4+2.D0*(M2+M3))/6.D0
  30    CONTINUE
C   NORMALISATION ::
  40    DAN=CFSIM(P(0),DP(0),NRAD,H,DR(0))
	DELFI(0)=-DAN*FI(0)
	DELFID(0)=-DAN*FID(0)
	DO 50 I=1,NRAD
	DELFI(I)=DP(I)/R(I)-DAN*FI(I)
	DELFID(I)=DQ(I)/R(I)+L*DP(I)/R(I)/R(I)-DAN*FID(I)
  50    CONTINUE
C ****** RELATIVISTIC VERSION ******
	ELSEIF(LCR.EQ.1)THEN
	L2=DBLE(L1*(L1-1))
	QL=SQRT(L2+1.D0-Z(0)**2*C2)
C   ASSYMPTOTIC BEHAVIOR ::
	I0=0
  60    I0=I0+1
	IF(I0.GT.NRAD)STOP'<DELRADSCH>:: I0.GT.NRAD' 
	IF(FI(I0).EQ.0.D0)GOTO60
	AN=FI(I0)/R(I0)**(QL-1)
	DV0=DV(0)
	AL=-DV0*AN*(-2.D0*Z(0)*C2+(QL-1.D0)/Z(0))/(2.D0*QL+1.D0)
	I0=1
	P(0)=R(0)*FI(0)
	Q(0)=0.D0
	DP(0)=(0.D0,0.D0)
	DQ(0)=(0.D0,0.D0)
  70    DP(I0)=AL*R(I0)**(QL+1.D0)
	P(I0)=R(I0)*FI(I0)
	Q(I0)=R(I0)*FID(I0)/(1.D0+C2*(EN+Z(I0)/R(I0)))
	IF(ABS(DP(I0)).EQ.0.D0)THEN
	DQ(I0)=0.D0
	I0=I0+1
	IF(I0.EQ.NRAD+1)GOTO90
	GOTO70
	ENDIF
	DQ(I0)=R(I0)**(QL+1.D0)/(Z(0)*C2)*(AL*QL-DV0*AN*(QL-
     &  1.D0)/(Z(0)*C2))
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DV3=DR(I0)*DV(I0)*H
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2)
	P3=P(I0)
	Q3=Q(I0)
	DO 80 I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1)EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD-1)EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DV1=DV3
	IF(I.NE.NRAD-1)DV2=(R2+BETTA)*(9.D0*(DV(I)+DV(I+1))-
     &  DV(I-1)-DV(I+2))*6.25D-2*H
	IF(I.EQ.NRAD-1)DV2=(R2+BETTA)*(DV(I)+DV(I+1))*0.5D0*H
	DV3=DR(I+1)*DV(I+1)*H
	DS1=DS3
	DS2=DV2*(1.D0+L2/R2/R2*C2/(1.D0+EV2*C2)**2)
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2)
	P1=P3
	IF(I.NE.NRAD-1)P2=R2*(9.D0*(FI(I)+FI(I+1))-FI(I-1)-FI(I+2))*
     &  6.25D-2
	IF(I.EQ.NRAD-1)P2=R2*(FI(I)+FI(I+1))*0.5D0
	P3=R3*FI(I+1)
	Q1=Q3
	IF(I.NE.NRAD-1)Q2=R2*(9.D0*(FID(I)+FID(I+1))-FID(I-1)-FID(I+2))*
     &  6.25D-2/(1.D0+C2*EV2)
	IF(I.EQ.NRAD-1)Q2=R2*(FID(I)+FID(I+1))*0.5D0/(1.D0+C2*EV2)
	Q3=R3*FID(I+1)/(1.D0+C2*EV3)
	P(I+1)=P3
	Q(I+1)=Q3
C   **************
	K1=+A1*DQ(I)+B1*DP(I)-DV1*C2*Q1
	M1=-V1*DP(I)-B1*DQ(I)+DS1*P1
C   **************
	K2= A2*(DQ(I)+M1*0.5D0)+B2*(DP(I)+K1*0.5D0)-DV2*C2*Q2
	M2=-V2*(DP(I)+K1*0.5D0)-B2*(DQ(I)+M1*0.5D0)+DS2*P2
C   **************
	K3= A2*(DQ(I)+M2*0.5D0)+B2*(DP(I)+K2*0.5D0)-DV2*C2*Q2
	M3=-V2*(DP(I)+K2*0.5D0)-B2*(DQ(I)+M2*0.5D0)+DS2*P2
C   **************
	K4= A3*(DQ(I)+M3)+B3*(DP(I)+K3)-DV3*C2*Q3
	M4=-V3*(DP(I)+K3)-B3*(DQ(I)+M3)+DS3*P3
C   **************
	DP(I+1)=DP(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	DQ(I+1)=DQ(I)+(M1+M4+2.D0*(M2+M3))/6.D0
  80    CONTINUE
C   NORMALISATION ::
  90    DAN=CFSIM(P(0),DP(0),NRAD,H,DR(0))
	DELFI(0)=-DAN*FI(0)
	DELFID(0)=-DAN*FID(0)
	DO 100 I=1,NRAD
	DELFI(I)=DP(I)/R(I)-DAN*FI(I)
	DELFID(I)=(DQ(I)*(1.D0+C2*(EN+Z(I)/R(I)))-Q(I)*C2*DV(I))/R(I)-
     &  DAN*FID(I)
 100    CONTINUE
	ENDIF
	END


C********* INTEGRATION PROGRAM ***************
	FUNCTION CFSIM(T1,T2,NRAD,H,DR)
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	COMPLEX*16 CF,T2,S2,S4,CFSIM
	DIMENSION T1(0:NRADMAX),T2(0:NRADMAX),DR(0:NRADMAX)
	S4=4.D0*DR(1)*T1(1)*T2(1)
	S2=DR(0)*T1(0)*T2(0)+DR(NRAD)*T1(NRAD)*T2(NRAD)
	DO 10 J=2,NRAD-2,2
	S2=S2+2.D0*DR(J)*T1(J)*T2(J)
	S4=S4+4.D0*DR(J+1)*T1(J+1)*T2(J+1)
10      CONTINUE
	CFSIM=H*0.333333333333333333D0*(S2+S4)
	RETURN
	END
