	SUBROUTINE SINTPAR(IPAN)
***********************************************************
*  Calculates contribution to the interstitial potential  *
*  matrix elements from k=0 and large vectors G.          *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NDIV(3),NDIW(3)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),YLM(LIMLMB,0:NBASMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX),GINT,HHH
     &    ,VPSINT(0:NPLWMAX,NSPINMAX),EXPS(0:NBASMAX),EXPK(0:NBASMAX)
     &    ,CHIK(0:NBASMAX),CHIS(0:NBASMAX),CONV(0:NBASMAX)
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
	COMPLEX*16 XFUN(NDIMMAX,0:MBASMAX),VINT0(NDIMMAX,NDIMMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTR(3),PNTK(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &    ,PNT(3,KMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),EXIST
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER SCRFILE(100)*60
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                    !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PSVCOM/ VPS,VPSINT                           !!! from vpseudo
	COMMON /STORE1/ XFUN,VINT0                           !!! from intpar
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /MESH/   NPNT,PNT                             !!! from init
	COMMON /INTTR/  NDIV,NDIW                            !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /OUT0/   SCRFILE                              !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERSA
        INQUIRE(FILE=SCRFILE(18),EXIST=EXIST)
        IF(.NOT.EXIST)THEN
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	OPEN(UNIT=18,FILE=SCRFILE(18),STATUS='NEW',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
	IF(KEYT.EQ.0)RETURN
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL FTRMAT(PNTK,1,IPAN)
C  DO OVER SPINS
	DO 1000 ISPIN=1,NSPIN             !!! over spins
C  DO OVER LEFT INDEX
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)     !!! NG_1
	CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &  YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        CALL CONVOL1(VPSINT(0,ISPIN),CHIS(0),CONV(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  SET CONVOLUTION FROM THE TEILOR EXPANSION
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
	XFUN(IPAR1,IBAS)=CONV(IBAS) 
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
	IF(IPAR1.GE.IPAR)THEN
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	HHH=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	HHH=HHH+CONV(IBAS)*CHIK(IBAS)
	ENDDO
C  FILL UP THE MATRICES
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
C       IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C       IF(ABS(HIM).LE.1.D-10)HIM=0.D0
	IF(IPAR1.EQ.IPAR)HIM=0.D0
	VINT0(IPAR1,IPAR)=DCMPLX(HRE,+HIM)!!! the hamiltonian
	VINT0(IPAR,IPAR1)=DCMPLX(HRE,-HIM)!!! the hamiltonian
	ENDIF
        ENDDO                             !!! over m
        ENDDO                             !!! over l
        ENDDO                             !!! over energy
        ENDDO                             !!! over iatom
        ENDDO                             !!! over m1
        ENDDO                             !!! over l1
        ENDDO                             !!! over energy
        ENDDO                             !!! over iatom1
C  STORE DATA
	IREC=ISPIN
	WRITE(18,REC=IREC)((VINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
1000    CONTINUE                          !!! over spins
	END
