	SUBROUTINE PRINT3(IGPTB,MY,IQPNT,ITER)
********************************************************
*  Print data on the potential and density variations. *
********************************************************
	IMPLICIT REAL*8 (A-C,E-H,O-Z)
	IMPLICIT COMPLEX*16 (D)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,INDZPTB(NENVMAX),INDGPTB(0:NENVMAX)
	COMPLEX*16 CNUM0P,DELP(8),DEXPGR
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DPSMOM1(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMAD (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DPSMOM (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMRO (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMAG (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
        COMPLEX*16 DRHOPS1(0:NPLWMAX,NSPINMAX)
     &   ,DPOTPS(0:NPLWMAX,NSPINMAX),DRHOPS(0:NPLWMAX,NSPINMAX)
     &   ,DBXCPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &   ,DCHINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMGINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DPSINP(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMSINP(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
	DIMENSION SMT(NSORTMAX),ORTH(2:3),GPLW(3,0:NPLWMAX)
     &    ,TAU(3,NPAT),QPNT(3),QPTB(3,NENVMAX),GPTB(3,0:NENVMAX)
	CHARACTER TXTEL(NSORTMAX)*10,POL(-1:2)*1
        LOGICAL SYM(LMMAXV,NPAT)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT                 !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB   !!! from plwcrd
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB            !!! from plwptb
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
        COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
        COMMON /BASIS/  TAU                                 !!! from readstr
C Density:
	COMMON /DELRO/  DRHO,DMAG                           !!! from delrho
 	COMMON /DROMULT/DELMRO,DPSMOM,DPSMOM1,DELMAD,DELMAG !!! from multdro
        COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1               !!! from vcftr
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
        COMMON /DPSVCOM/DPOTPS,DBXCPS                       !!! from dvcftr
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
	COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /INPDCH/ DCHINP,DPSINP,DMGINP,DMSINP         !!! from print3
C Radial mesh:
	COMMON /RADMESH/NRAD                                !!! from radmsh
C Outputs:
	COMMON /TXTEL/  TXTEL                               !!! from readini
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/,POL/'m','z','p','v'/
	SQPI4=2.D0*SQRT(PI)
	WRITE(IUN,1001)POL(MY)
	WRITE(IUN,1002)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
1001    FORMAT(1X,'MAGNETIC FIELD POLARIZATION  "',A1,'" ')
1002    FORMAT(1X,'G',I2,'=(',G12.5,',',G12.5,',',G12.5,')')
	DO 2000 IATOM=1,NATOM                         !!! over atoms
	ISORT=IS(IATOM)
	WRITE(IUN,1011)IATOM,TXTEL(ISORT)
1011    FORMAT(1X,'Data  variation ::  atom position ',I2,'  ' ,A10)
C  POTENTIAL INFORMATION
	DELP(1)=0.5D0*(DPOT(NRAD(ISORT),1,IATOM,1)+
     &  DPOT(NRAD(ISORT),1,IATOM,NSPIN))/SQPI4
	DELP(2)=0.5D0*(DPOT(NRAD(ISORT),1,IATOM,1)-
     &  DPOT(NRAD(ISORT),1,IATOM,NSPIN))/SQPI4
	DELP(3)=DBXC(NRAD(ISORT),1,IATOM,1)/SQPI4
	DELP(4)=DBXC(NRAD(ISORT),1,IATOM,NSPIN)/SQPI4
        DELP(5)=(0.D0,0.D0)
        DELP(6)=(0.D0,0.D0)
        DELP(7)=(0.D0,0.D0)
        DELP(8)=(0.D0,0.D0)
        DO IPLW=0,NPLW
        GX=QPNT(1)+GPLW(1,IPLW)
        GY=QPNT(2)+GPLW(2,IPLW)
        GZ=QPNT(3)+GPLW(3,IPLW)
        SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
        GS=SQRT(GX**2+GY**2+GZ**2)*2.D0*PI/PAR*SMT(ISORT)
        DEXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
        IF(GS.GE.1.D-10)THEN
	DELP(5)=DELP(5)+DEXPGR*SIN(GS)/GS*
     &  (DPOTPS(IPLW,1)+DPOTPS(IPLW,NSPIN))/2.D0 
	DELP(6)=DELP(6)+DEXPGR*SIN(GS)/GS*
     &  (DPOTPS(IPLW,1)-DPOTPS(IPLW,NSPIN))/2.D0 
	DELP(7)=DELP(7)+DEXPGR*SIN(GS)/GS*DBXCPS(IPLW,1)
	DELP(8)=DELP(8)+DEXPGR*SIN(GS)/GS*DBXCPS(IPLW,NSPIN)
	ENDIF
        IF(GS.LT.1.D-10)THEN
	DELP(5)=DELP(5)+DEXPGR*
     &  (DPOTPS(IPLW,1)+DPOTPS(IPLW,NSPIN))/2.D0 
	DELP(6)=DELP(6)+DEXPGR*
     &  (DPOTPS(IPLW,1)-DPOTPS(IPLW,NSPIN))/2.D0 
	DELP(7)=DELP(7)+DEXPGR*DBXCPS(IPLW,1)
	DELP(8)=DELP(8)+DEXPGR*DBXCPS(IPLW,NSPIN)
	ENDIF
        ENDDO
	WRITE(IUN,1020)
	WRITE(IUN,1021)CNUM0P(DELP(1),1.D-07)
	WRITE(IUN,1022)CNUM0P(DELP(5),1.D-07)
	WRITE(IUN,1023)CNUM0P(DELP(2),1.D-07)
	WRITE(IUN,1024)CNUM0P(DELP(3),1.D-07)
	WRITE(IUN,1025)CNUM0P(DELP(4),1.D-07)
	WRITE(IUN,1026)CNUM0P(DELP(6),1.D-07)
	WRITE(IUN,1027)CNUM0P(DELP(7),1.D-07)
	WRITE(IUN,1028)CNUM0P(DELP(8),1.D-07)
1020	FORMAT(1X,'Screened potential and magnetic fields ------->')
1021    FORMAT(1X,'Total potential Dpot(S) = (',G14.7,',',G14.7,')')
1022    FORMAT(1X,'Pseudopotential Ppot(S) = (',G14.7,',',G14.7,')')
1023    FORMAT(1X,'Z magnet. field DBm0(S) = (',G14.7,',',G14.7,')')
1024    FORMAT(1X,'M magnet. filed DBm_(S) = (',G14.7,',',G14.7,')')
1025    FORMAT(1X,'P magnet. field DBm+(S) = (',G14.7,',',G14.7,')')
1026    FORMAT(1X,'Z magnet. field PBm0(S) = (',G14.7,',',G14.7,')')
1027    FORMAT(1X,'M magnet. filed PBm_(S) = (',G14.7,',',G14.7,')')
1028    FORMAT(1X,'P magnet. field PBm+(S) = (',G14.7,',',G14.7,')')
C  CHARGE DENSITY INFORMATION
	DELP(1)=0.5D0*DBLE(NSPIN)*(DRHO(NRAD(ISORT),1,IATOM,1)+
     &  DRHO(NRAD(ISORT),1,IATOM,NSPIN))/SQPI4
	DELP(2)=(DRHO(NRAD(ISORT),1,IATOM,1)-
     &  DRHO(NRAD(ISORT),1,IATOM,NSPIN))/SQPI4
	DELP(3)=DMAG(NRAD(ISORT),1,IATOM,1)/SQPI4
	DELP(4)=DMAG(NRAD(ISORT),1,IATOM,NSPIN)/SQPI4
        DELP(5)=(0.D0,0.D0)
        DELP(6)=(0.D0,0.D0)
        DELP(7)=(0.D0,0.D0)
        DELP(8)=(0.D0,0.D0)
        DO IPLW=0,NPLW
        GX=QPNT(1)+GPLW(1,IPLW)
        GY=QPNT(2)+GPLW(2,IPLW)
        GZ=QPNT(3)+GPLW(3,IPLW)
        SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
        GS=SQRT(GX**2+GY**2+GZ**2)*2.D0*PI/PAR*SMT(ISORT)
        DEXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
        IF(GS.GE.1.D-10)THEN
	DELP(5)=DELP(5)+DEXPGR*SIN(GS)/GS*
     &  (DRHOPS(IPLW,1)+DRHOPS(IPLW,NSPIN))/2.D0*DBLE(NSPIN) 
	DELP(6)=DELP(6)+DEXPGR*SIN(GS)/GS*
     &  (DRHOPS(IPLW,1)-DRHOPS(IPLW,NSPIN))
	DELP(7)=DELP(7)+DEXPGR*SIN(GS)/GS*DMAGPS(IPLW,1)
	DELP(8)=DELP(8)+DEXPGR*SIN(GS)/GS*DMAGPS(IPLW,NSPIN)
	ENDIF
        IF(GS.LT.1.D-10)THEN
	DELP(5)=DELP(5)+DEXPGR*
     &  (DRHOPS(IPLW,1)+DRHOPS(IPLW,NSPIN))/2.D0*DBLE(NSPIN) 
	DELP(6)=DELP(6)+DEXPGR*
     &  (DRHOPS(IPLW,1)-DRHOPS(IPLW,NSPIN))
	DELP(7)=DELP(7)+DEXPGR*DMAGPS(IPLW,1)
	DELP(8)=DELP(8)+DEXPGR*DMAGPS(IPLW,NSPIN)
	ENDIF
        ENDDO
	WRITE(IUN,1030)
	WRITE(IUN,1031)CNUM0P(DELP(1),1.D-07)
	WRITE(IUN,1032)CNUM0P(DELP(5),1.D-07)
	WRITE(IUN,1033)CNUM0P(DELP(2),1.D-07)
	WRITE(IUN,1034)CNUM0P(DELP(3),1.D-07)
	WRITE(IUN,1035)CNUM0P(DELP(4),1.D-07)
	WRITE(IUN,1036)CNUM0P(DELP(6),1.D-07)
	WRITE(IUN,1037)CNUM0P(DELP(7),1.D-07)
	WRITE(IUN,1038)CNUM0P(DELP(8),1.D-07)
1030	FORMAT(1X,'Induced density and magnetization      ------->')
1031    FORMAT(1X,'Induced density Drho(S) = (',G14.7,',',G14.7,')')
1032    FORMAT(1X,'Pseudo  density Prho(S) = (',G14.7,',',G14.7,')')
1033    FORMAT(1X,'Z Magnetization DMg0(S) = (',G14.7,',',G14.7,')')
1034    FORMAT(1X,'M Magnetization DMg_(S) = (',G14.7,',',G14.7,')')
1035    FORMAT(1X,'P Magnetization DMg+(S) = (',G14.7,',',G14.7,')')
1036    FORMAT(1X,'Z Pseudomagnetz PMg0(S) = (',G14.7,',',G14.7,')')
1037    FORMAT(1X,'M Pseudomagentz PMg_(S) = (',G14.7,',',G14.7,')')
1038    FORMAT(1X,'P Pseudomagentz PMg+(S) = (',G14.7,',',G14.7,')')
C  INDUCED CHARGE AND MAGNETIC MOMENTS
	DELP(1)=(DELMRO(1,IATOM,1,IGPTB,MY)+
     &  DELMRO(1,IATOM,NSPIN,IGPTB,MY))/2.D0*DBLE(NSPIN)
	DELP(2)=(DPSMOM(1,IATOM,1,IGPTB,MY)+
     &  DPSMOM(1,IATOM,NSPIN,IGPTB,MY))/2.D0*DBLE(NSPIN)
	DELP(3)=DELMRO(1,IATOM,1,IGPTB,MY)-
     &  DELMRO(1,IATOM,NSPIN,IGPTB,MY)
	DELP(4)=DELMAG(1,IATOM,1,IGPTB,MY)
	DELP(5)=DELMAG(1,IATOM,NSPIN,IGPTB,MY)
	WRITE(IUN,1040)
	WRITE(IUN,1041)CNUM0P(DELP(1),1.D-07)
	WRITE(IUN,1042)CNUM0P(DELP(2),1.D-07)
	WRITE(IUN,1043)CNUM0P(DELP(3),1.D-07)
	WRITE(IUN,1044)CNUM0P(DELP(4),1.D-07)
	WRITE(IUN,1045)CNUM0P(DELP(5),1.D-07)
1040	FORMAT(1X,'Induced charges and magnetic moments   ------->')
1041    FORMAT(1X,'Induced charge in S_mt  = (',G14.7,',',G14.7,')')
1042    FORMAT(1X,'Pseudo  charge in S_mt  = (',G14.7,',',G14.7,')')
1043    FORMAT(1X,'Z Magnetic moment Dmom0 = (',G14.7,',',G14.7,')')
1044    FORMAT(1X,'M Magnetic moment Dmom_ = (',G14.7,',',G14.7,')')
1045    FORMAT(1X,'P Magnetic moment Dmom+ = (',G14.7,',',G14.7,')')
2000	CONTINUE                                       !!! over atoms
C SAVE INPUT INDUCED CHARGE TRANSFER AND MAGNETIC MOMENT
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DCHINP(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DELMRO(LM,IATOM,ISPIN,IGPTB,MY)
        DMGINP(LM,IATOM,ITRAN,IGPTB,MY)=
     &  DELMAG(LM,IATOM,ITRAN,IGPTB,MY)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C SAVE INPUT INDUCED PSEUDOCHARGE AND MAGNETIC MOMENT
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IZPTB=1,NZPTB
	IPLW=INDZPTB(IZPTB)
	DPSINP(IZPTB,ISPIN,IGPTB,MY)=DRHOPS(IPLW,ISPIN)+
     &  DRHOPS1(IPLW,ISPIN)
	DMSINP(IZPTB,ITRAN,IGPTB,MY)=DMAGPS(IPLW,ITRAN)
	ENDDO
	ENDDO
	RETURN
	END




        SUBROUTINE PRINT4(IGPTB,MY,IQPNT,KEY)
********************************************************
*  Print input/output induced-charge transfer.         *
********************************************************
        IMPLICIT REAL*8 (A-C,E-H,O-Z)
        IMPLICIT COMPLEX*16 (D)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX),INDZPTB(NENVMAX)
     &   ,INDGPTB(0:NENVMAX)
        COMPLEX*16 CNUM0P,DRHOPS1(0:NPLWMAX,NSPINMAX)
     &   ,DPSMOM1(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMAD(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMAG(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DPSMOM(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMRO(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DCHINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DCHOUT(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMGINP(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMGOUT(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DRHOPS(0:NPLWMAX,NSPINMAX)
     &   ,DMAGPS(0:NPLWMAX,NSPINMAX)
	COMPLEX*16 DIFF,DIPINP(0:NENVMAX,-1:2)
     &   ,DIPOUT(0:NENVMAX,-1:2),EXPQR,DELP(8)
     &   ,PSMAT(NENVMAX,NENVMAX,NSPINMAX),SCRINT(NENVMAX,0:NENVMAX,-1:2)
     &   ,SCRMAT(NENVMAX,NENVMAX),DIEMAT(NENVMAX,NENVMAX)
     &   ,DPSINP(NENVMAX,NSPINMAX,0:NENVMAX,-1:2),TOTINP,TOTOUT,TOTSCR
     &   ,DPSOUT(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMSINP(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DMSOUT(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DPSSCR(NENVMAX,NSPINMAX,0:NENVMAX,-1:2)
        DIMENSION SMT(NSORTMAX),QPNT(3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),QPTB(3,NENVMAX),GPTB(3,0:NENVMAX)
        CHARACTER TXTEL(NSORTMAX)*10,POL(-1:2)*1
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT                 !!! from readini
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
        COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /BASIS/  TAU                                 !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
        COMMON /POTCOM/ SWZ,SMT                             !!! from readini
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB            !!! from plwptb
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB   !!! from plwcrd
C Polarizability:
        COMMON /PLZMOM/ PSMAT,SCRMAT,DIEMAT,SCRINT          !!! from screen
C Density:
        COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1               !!! from vcftr
 	COMMON /DROMULT/DELMRO,DPSMOM,DPSMOM1,DELMAD,DELMAG !!! from multdro
        COMMON /INPDCH/ DCHINP,DPSINP,DMGINP,DMSINP         !!! from print3
     &                 ,DCHOUT,DPSOUT,DMGOUT,DMSOUT         !!! from print4
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
C Radial mesh:
        COMMON /RADMESH/NRAD                                !!! from radmsh
C Outputs:
        COMMON /UNIT/   IUN                                 !!! from readini
        COMMON /TXTEL/  TXTEL                               !!! from readini
        SAVE TOTINP,TOTOUT,TOTSCR,DIPINP,DIPOUT,DPSSCR
        DATA PI/3.141592653589793D0/,POL/'m','z','p','v'/
        SQPI4=2.D0*SQRT(PI)
C  GET SCREENED CHARGE TRANSFER
        IF(KEY.EQ.1)THEN
	DO IZPTB=1,NZPTB
	DO ISPIN=1,NSPIN                             !!! over spins
	DPSSCR(IZPTB,ISPIN,IGPTB,MY)=(0.D0,0.D0)
	DO JZPTB=1,NZPTB
	JPLW=INDZPTB(JZPTB)
	DPSSCR(IZPTB,ISPIN,IGPTB,MY)=DPSSCR(IZPTB,ISPIN,IGPTB,MY)+
     &  DIEMAT(IZPTB,JZPTB)*(DRHOPS(JPLW,ISPIN)+
     &  DRHOPS1(JPLW,ISPIN))
	ENDDO
        ENDDO                                        !!! over spins
	ENDDO
C  SET SCREENED LONG-RANGE INTERACTION
	DO IZPTB=1,NZPTB
	SCRINT(IZPTB,IGPTB,MY)=(0.D0,0.D0)
	DO JZPTB=1,NZPTB
	JPLW=INDZPTB(JZPTB)
        SCRINT(IZPTB,IGPTB,MY)=SCRINT(IZPTB,IGPTB,MY)+
     &  SCRMAT(IZPTB,JZPTB)*(
     &  (DRHOPS (JPLW,1)+DRHOPS (JPLW,NSPIN))/2.D0*DBLE(NSPIN)+
     &  (DRHOPS1(JPLW,1)+DRHOPS1(JPLW,NSPIN))/2.D0*DBLE(NSPIN))
	ENDDO
	ENDDO
C  *** PRINT BLOCK *****
        ELSEIF(KEY.EQ.2)THEN
C  OUTPUT INDUCED CHARGE TRANSFER AND MAGNETIC MOMENT
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DCHOUT(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DELMRO(LM,IATOM,ISPIN,IGPTB,MY)
        DMGOUT(LM,IATOM,ITRAN,IGPTB,MY)=
     &  DELMAG(LM,IATOM,ITRAN,IGPTB,MY)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  OUTPUT INDUCED PSEUDOCHARGE 
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IZPTB=1,NZPTB
	IPLW=INDZPTB(IZPTB)
	DPSOUT(IZPTB,ISPIN,IGPTB,MY)=DRHOPS(IPLW,ISPIN)+
     &  DRHOPS1(IPLW,ISPIN)
	DMSOUT(IZPTB,ITRAN,IGPTB,MY)=DMAGPS(IPLW,ITRAN)
	ENDDO
	ENDDO
	WRITE(IUN,1001)POL(MY)
        WRITE(IUN,1002)IGPTB,GPTB(1,IGPTB),GPTB(2,IGPTB),GPTB(3,IGPTB)
        WRITE(IUN,1000)
1000    FORMAT(1X,'Input/output induced charge transfer, dQ_iat-->')
1001    FORMAT(1X,'MAGNETIC FIELD POLARIZATION  "',A1,'" ')
1002    FORMAT(1X,'G',I2,'=(',G12.5,',',G12.5,',',G12.5,')')
        DO IATOM=1,NATOM                         !!! over atoms
        ISORT=IS(IATOM)
        WRITE(IUN,1010)TXTEL(ISORT)
1010    FORMAT(1X,23X,'dM_iat[INP]',19X,'dM_iat[OUT]',3X,A10)
C  INDUCED CHARGE AND MAGNETIC MOMENTS
	DELP(1)=CNUM0P(DCHINP(1,IATOM,1,IGPTB,MY)+
     &  DCHINP(1,IATOM,NSPIN,IGPTB,MY),1.D-07)/2.D0*DBLE(NSPIN)
	DELP(2)=CNUM0P(DCHINP(1,IATOM,1,IGPTB,MY)-
     &  DCHINP(1,IATOM,NSPIN,IGPTB,MY),1.D-07)
	DELP(3)=CNUM0P(DMGINP(1,IATOM,1,IGPTB,MY),1.D-07)
	DELP(4)=CNUM0P(DMGINP(1,IATOM,NSPIN,IGPTB,MY),1.D-07)
	DELP(5)=CNUM0P(DCHOUT(1,IATOM,1,IGPTB,MY)+
     &  DCHOUT(1,IATOM,NSPIN,IGPTB,MY),1.D-07)/2.D0*DBLE(NSPIN)
	DELP(6)=CNUM0P(DCHOUT(1,IATOM,1,IGPTB,MY)-
     &  DCHOUT(1,IATOM,NSPIN,IGPTB,MY),1.D-07)
	DELP(7)=CNUM0P(DMGOUT(1,IATOM,1,IGPTB,MY),1.D-07)
	DELP(8)=CNUM0P(DMGOUT(1,IATOM,NSPIN,IGPTB,MY),1.D-07)
	WRITE(IUN,1021)DELP(1),DELP(5)
	WRITE(IUN,1022)DELP(2),DELP(6)
	WRITE(IUN,1023)DELP(3),DELP(7)
	WRITE(IUN,1024)DELP(4),DELP(8)
1021    FORMAT(1X,' Charge  :',2X,'(',G12.5,',',G12.5,')',2X,
     &                            '(',G12.5,',',G12.5,')')
1022    FORMAT(1X,'Z-Moment :',2X,'(',G12.5,',',G12.5,')',2X,
     &                            '(',G12.5,',',G12.5,')')
1023    FORMAT(1X,'M-Moment :',2X,'(',G12.5,',',G12.5,')',2X,
     &                            '(',G12.5,',',G12.5,')')
1024    FORMAT(1X,'P-Moment :',2X,'(',G12.5,',',G12.5,')',2X,
     &                            '(',G12.5,',',G12.5,')')
        ENDDO                                       !!! over atoms
        WRITE(IUN,1030)
	DO IZPTB=1,NZPTB
	DELP(1)=CNUM0P(DPSINP(IZPTB,1,IGPTB,MY)+
     &  DPSINP(IZPTB,NSPIN,IGPTB,MY),
     &  1.D-07)/2.D0*DBLE(NSPIN)*OMEGAC
	DELP(2)=CNUM0P(DPSINP(IZPTB,1,IGPTB,MY)-
     &  DPSINP(IZPTB,NSPIN,IGPTB,MY),
     &  1.D-07)*OMEGAC
	DELP(3)=CNUM0P(DMSINP(IZPTB,1,IGPTB,MY),1.D-07)*
     &  OMEGAC
	DELP(4)=CNUM0P(DMSINP(IZPTB,NSPIN,IGPTB,MY),1.D-07)*
     &  OMEGAC
	DELP(5)=CNUM0P(DPSOUT(IZPTB,1,IGPTB,MY)+
     &  DPSOUT(IZPTB,NSPIN,IGPTB,MY),1.D-07)/2.D0*DBLE(NSPIN)*
     &  OMEGAC
	DELP(6)=CNUM0P(DPSOUT(IZPTB,1,IGPTB,MY)-
     &  DPSOUT(IZPTB,NSPIN,IGPTB,MY),1.D-07)*OMEGAC
	DELP(7)=CNUM0P(DMSOUT(IZPTB,1,IGPTB,MY),1.D-07)*
     &  OMEGAC
	DELP(8)=CNUM0P(DMSOUT(IZPTB,NSPIN,IGPTB,MY),1.D-07)*
     &  OMEGAC
	WRITE(IUN,1031)IZPTB,DELP(1),DELP(5)
	WRITE(IUN,1032)IZPTB,DELP(2),DELP(6)
	WRITE(IUN,1033)IZPTB,DELP(3),DELP(7)
	WRITE(IUN,1034)IZPTB,DELP(4),DELP(8)
1030    FORMAT(1X,23X,'dP_tot[INP]',19X,'dP_tot[OUT]',3X,'TOTAL')
1031    FORMAT(1X,'Drho(G',I2,'):',2X,'(',G12.5,',',G12.5,')',2X,
     &                                '(',G12.5,',',G12.5,')')
1032    FORMAT(1X,'DmsZ(G',I2,'):',2X,'(',G12.5,',',G12.5,')',2X,
     &                                '(',G12.5,',',G12.5,')')
1033    FORMAT(1X,'DmsM(G',I2,'):',2X,'(',G12.5,',',G12.5,')',2X,
     &                                '(',G12.5,',',G12.5,')')
1034    FORMAT(1X,'DmsP(G',I2,'):',2X,'(',G12.5,',',G12.5,')',2X,
     &                                '(',G12.5,',',G12.5,')')
	ENDDO
C  CHECK SCREENED CHARGE TRANSFER
	IF(LPLZ.GT.0)THEN
	DO IZPTB=1,NZPTB
        IF(ABS(DPSSCR(IZPTB,1,IGPTB,MY)+DPSSCR(IZPTB,NSPIN,IGPTB,MY)-
     &         DPSOUT(IZPTB,1,IGPTB,MY)-DPSOUT(IZPTB,NSPIN,IGPTB,MY))
     &  .GT.1.D-06)PRINT*,
     &  '<PRINT4>:: ERROR IN SCREENED CHARGE ::',
     &  (DPSOUT(IZPTB,1,IGPTB,MY)+DPSOUT(IZPTB,NSPIN,IGPTB,MY))/
     &  2.D0*DBLE(NSPIN)*OMEGAC,
     &  (DPSSCR(IZPTB,1,IGPTB,MY)+DPSSCR(IZPTB,NSPIN,IGPTB,MY))/
     &  2.D0*DBLE(NSPIN)*OMEGAC
	ENDDO
	ENDIF
        ENDIF
        RETURN
        END
