	SUBROUTINE DSHUBPAR(IGPTB,MY,IPAN,IQPNT)
***************************************************************
*   Adds Hubbard correction to the potential parameters.      *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NRAD(NSORTMAX),NKAP(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,DELHHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &    ,DELHJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &    ,DELHHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &    ,DELHJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &    ,DELOHH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELOJH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELOHJ(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELOJJ(NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,HMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,OMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
        COMPLEX*16 AVT,DVT
     &    ,VHUB(LIMLMB2,NPAT,NSPINMAX),DHUB(LIMLMB2,NPAT,NSPINMAX)
     &    ,VCNS(LIMLMB2,NPAT,NSPINMAX),DLDA(LIMLMB2,NPAT,NSPINMAX)
     &    ,DELVHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELBHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELVCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELBCNS(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELDLDA(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
	DIMENSION SMT(NSORTMAX),GAM(0:LMAXT,NSORTMAX)
	LOGICAL LOG1,LOG,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER*60 SCRFILE(100) 
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS            !!! from init
	COMMON /LMTPAR/ GAM                              !!! from potpar
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /ORBS/   NORBS                            !!! from init
        COMMON /MTPAR / HMTHH,HMTJH,HMTHJ,HMTJJ,OMTHH,OMTJH,OMTHJ,OMTJJ
        COMMON /STORE1/ DELHHH,DELHJH,DELHHJ,DELHJJ      !!! from dnmtpar
        COMMON /HUBCOM/ DHUB,VHUB,DLDA,VCNS              !!! from hubpot
        COMMON /DELHUB/ DELDHUB,DELMHUB,DELVHUB,DELBHUB
     &                 ,DELDLDA,DELVCNS,DELBCNS 
        COMMON /DOVRPAR/DELOHH,DELOJH,DELOHJ,DELOJJ      !!! from delmat
	COMMON /INP1/   ICHUB                            !!! from readini
        COMMON /EXCH/   IEXCH                            !!! from readini
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(ICHUB.EQ.0)RETURN
	IF(IPAN .NE.1)RETURN
C ***** DO GLOBALLY OVER SPINORS ********
        DO 5000 IUPDN1=1,NSPIN                     !!! over spinors
        DO 4000 IUPDN =1,NSPIN                     !!! over spinors
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO4000
        ISPIN=1
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO4000
        ISPIN=2
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO4000
        ISPIN=0
        ITRAN=2
        SIGNF=-SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO4000
        ISPIN=0
        ITRAN=1
        SIGNF=+SQRT(2.D0)
        ENDIF
C READ CHANGE IN NMT-PARAMETERS
        IF(ISPIN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,41,'R')
        IF(ITRAN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,43,'R')
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
        DO 2000 IKAP1=1,NKAP(IPAN)     !!! over energy
        DO 1000 IKAP =1,NKAP(IPAN)     !!! over energy
C ADD HUBBARD POTENTIAL
	DO L=0,ILSB(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	IF(ISPIN.NE.0)THEN
	DVT=DELVHUB(IU,IATOM,ISPIN,IGPTB,MY)+
     &      DELVCNS(IU,IATOM,ISPIN,IGPTB,MY)
        IF(LOG1.AND.LOG)
     &  DELHHH(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHH(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)*DVT*SIGNF
        IF(LOG)
     &  DELHJH(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJH(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)*DVT*SIGNF
        IF(LOG1)
     &  DELHHJ(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHJ(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)*DVT*SIGNF
        DELHJJ(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJJ(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)*DVT*SIGNF
	ENDIF
	IF(ITRAN.NE.0)THEN
	DVT=DELBHUB(IU,IATOM,ITRAN,IGPTB,MY)+
     &      DELBCNS(IU,IATOM,ITRAN,IGPTB,MY)
        IF(LOG1.AND.LOG)
     &  DELHHH(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHH(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTHH(IKAP1,IKAP,L,ISORT,ITRAN)*DVT*SIGNF
        IF(LOG)
     &  DELHJH(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJH(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTJH(IKAP1,IKAP,L,ISORT,ITRAN)*DVT*SIGNF
        IF(LOG1)
     &  DELHHJ(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHJ(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ITRAN)*DVT*SIGNF
        DELHJJ(LM1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJJ(LM1,LM,IATOM,IKAP1,IKAP)+
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ITRAN)*DVT*SIGNF
	ENDIF
        ENDDO                          !!! over m
        ENDDO                          !!! over m1
        ENDDO                          !!! over l
1000    CONTINUE                       !!! over ikap
2000    CONTINUE                       !!! over ikap1
3000    CONTINUE                       !!! over atoms
C STORE CHANGE IN NMT-PARAMETERS
        IF(ISPIN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,41,'W')
        IF(ITRAN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,43,'W')
4000    CONTINUE                       !!! over spinors
5000    CONTINUE                       !!! over spinors
	END
