	SUBROUTINE DSINTPAR(IGPTB,MY,IPAN,IQPNT)
***********************************************************
*  Calculates contribution to the change in the           *
*  interstitial potential matrix elements from k=0        *
*  and large vectors G.                                   *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NDIV(3),NDIW(3)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &   ,DPOTPS(0:NPLWMAX,NSPINMAX),DBXCPS(0:NPLWMAX,NSPINMAX)
     &   ,DPOTIN(0:NPLWMAX,NSPINMAX),DBXCIN(0:NPLWMAX,NSPINMAX)
     &   ,DXFUN0(NDIMMAX,0:MBASMAX),DVINT0(NDIMMAX,NDIMMAX)
     &   ,DXFUNQ(NDIMMAX,0:MBASMAX),DVINTQ(NDIMMAX,NDIMMAX)
     &   ,CFTR0(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX),DHH0,DHHQ
     &   ,CFTRQ(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &   ,YLMQ(LIMLMB,0:NBASMAX),YLM0(LIMLMB,0:NBASMAX)
     &   ,CHI0(0:NBASMAX),CON0(0:NBASMAX),EXP0(0:NBASMAX)
     &   ,CHIQ(0:NBASMAX),CONQ(0:NBASMAX),EXPQ(0:NBASMAX)
     &   ,EXS0(0:NBASMAX),EXSQ(0:NBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &   ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTR(3),PNTK(3)
     &   ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &   ,PNT(3,KMAX),QPNT(3)  
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),EXIST
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER SCNFILE(0:NENVMAX,-1:2,100)*60,STATUS*3
C Controls:
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /ORBS/   NORBS                                !!! from init
C Inputs:
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
C Potential:
        COMMON /DPSVCOM/DPOTPS,DBXCPS,DPOTIN,DBXCIN          !!! from potfiles
C K-Mesh:
	COMMON /MESH/   NPNT,PNT                             !!! from init
	COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
	COMMON /INTTR/  NDIV,NDIW                            !!! from init
C Temporary:
	COMMON /STORE1/ DXFUN0,DVINT0                        !!! from rintpar
	COMMON /DELPOT/ DXFUNQ,DVINTQ                        !!! from rintpar
	COMMON /DELRO/  CFTRQ,YLMQ                           !!! from ftrmat
	COMMON /DENS/   PNTR,CFTR0,YLM0                      !!! from ftrmat
C Plane waves:
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
C Outputs:
	COMMON /OUT0PH/ SCNFILE                              !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	INQUIRE(FILE=SCNFILE(IGPTB,MY,45),EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	OPEN(UNIT=45,FILE=SCNFILE(IGPTB,MY,45),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	INQUIRE(FILE=SCNFILE(IGPTB,MY,46),EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	OPEN(UNIT=46,FILE=SCNFILE(IGPTB,MY,46),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IF(KEYT.EQ.0)THEN
	CLOSE(45)
	CLOSE(46)
	RETURN
	ENDIF
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1)
	PNTK(2)=QPNT(2)
	PNTK(3)=QPNT(3)
	CALL FTRMAT(PNTK,1,IPAN)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL FTRMAT(PNTK,1,IPAN)
C ***** DO GLOBALLY OVER SPINORS ********
        DO 2000 IUPDN1=1,NSPIN                     !!! over spinors
        DO 1000 IUPDN =1,NSPIN                     !!! over spinors
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO1000
        ISPIN=1
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO1000
        ISPIN=2
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO1000
        ISPIN=0
        ITRAN=2
        SIGNF=-SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO1000
        ISPIN=0
        ITRAN=1
        SIGNF=+SQRT(2.D0)
        ENDIF
C  ####################################################
C  ORIGINAL CONVOLUTIONS OF PSEUDOORBITALS
C  ####################################################
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+QPNT(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+QPNT(3))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	CHI0(IBAS)=CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS))
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
	IF(ISPIN.NE.0)THEN
        CALL CONVOL1(DPOTIN(0,ISPIN),CHI0(0),CON0(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
        CALL CONVOL1(DPOTIN(0,ISPIN),CHIQ(0),CONQ(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	ELSEIF(ITRAN.NE.0)THEN
        CALL CONVOL1(DBXCIN(0,ITRAN),CHI0(0),CON0(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
        CALL CONVOL1(DBXCIN(0,ITRAN),CHIQ(0),CONQ(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	ENDIF
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)*SIGNF!! dX0/d{t1m1}
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)*SIGNF!! dYq/d{t1m1}
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*YLM0(LM,IBAS)*EXS0(IBAS)
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CONQ(IBAS)*CHI0(IBAS)         !!! dV/d{t1m1}
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0*SIGNF     !!! the hamiltonian
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA
	IF(ISPIN.NE.0)THEN
	IREC=ISPIN                        !!! dX0/d{t1m1},dV/d{t1m1}
	WRITE(45,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DXFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
	ELSEIF(ITRAN.NE.0)THEN
	IREC=ITRAN                        !!! dX0/d{t1m1},dV/d{t1m1}
	WRITE(46,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DXFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
	ENDIF
1000    CONTINUE                       !!! over spinors
2000    CONTINUE                       !!! over spinors
	CLOSE(45)
	CLOSE(46)
	END
