	SUBROUTINE DSNMTPAR(IGPTB,MY,IPAN,IQPNT)
***************************************************************
*   Calculate potential parameter variation of the NMT-       *
*   contribution to the hamiltonian matrix.                   *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX),LR(NSORTMAX)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX)
     &   ,ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 RADMAT(4,0:LMAXT,0:LMAXT,LMMAXV),DELV
     &   ,DELHHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DHMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX)
     &   ,DHMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX)
     &   ,DHMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX)
     &   ,DHMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,FIH(0:NRADMAX,0:LMAXT,NKAPMAX,NSPINMAX)
     &   ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX,NSPINMAX)
     &   ,DELFIH(0:NRADMAX,0:LMAXT,2,NKAPMAX),WORK1(0:NRADMAX)
     &   ,DELFIJ(0:NRADMAX,0:LMAXT,2,NKAPMAX),WORK2(0:NRADMAX)
	COMPLEX*16 DVT(0:NRADMAX)
     &   ,DELAAH(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBBH(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELAAJ(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELBBJ(0:LMAXT,NPAT,NKAPMAX,2,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DELENY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDNY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELTNY(0:LMAXT,NPAT,NKAPMAX,NPANMAX,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DFI(0:NRADMAX,0:LMAXT),DFID(0:NRADMAX,0:LMAXT)
     &   ,DFIP(0:NRADMAX,0:LMAXT),DFIDP(0:NRADMAX,0:LMAXT)
     &   ,DFIDDS(0:LMAXT),DFIDDPS(0:LMAXT)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	DIMENSION  SMT(NSORTMAX),VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,AFI(0:NRADMAX,0:LMAXT),AFID(0:NRADMAX,0:LMAXT)
     &   ,AFIP(0:NRADMAX,0:LMAXT),AFIDP(0:NRADMAX,0:LMAXT)
     &   ,AFIDDS(0:LMAXT),AFIDDPS(0:LMAXT)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG,EXIST
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE     !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /ORBS/   NORBS                            !!! from init
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /DLFCOM/ NDLF,LDLF,IDLF                   !!! from init
	COMMON /RELATIV/LR                               !!! from init
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                   !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS            !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                        !!! from symmlm 
C Pot.pars:
	COMMON /INPPAR/ TNY,ENY,DNY                      !!! from potpar
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ              !!! from lmtpar
	COMMON /DINPPAR/DELTNY,DELENY,DELDNY             !!! from dpotpar
	COMMON /DLMTPAR/DELAAH,DELBBH,DELAAJ,DELBBJ      !!! from dpotpar
	COMMON /DMTPAR/ DHMTHH,DHMTJH,DHMTHJ,DHMTJJ      !!! from dlmtpar
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                        !!! from delpot
C Temporary:
	COMMON /STORE1/ DELHHH,DELHJH,DELHHJ,DELHJJ      !!! from dnmtpar
	COMMON /STORE2/ RADMAT,AFI,AFID,AFIP,AFIDP,FIH,FIJ!! tmp.storage
     &                 ,DFI,DFID,DFIP,DFIDP,DELFIH,DELFIJ!!! tmp.storage 
C Gaunts:
	COMMON /GAUNT/  C                                !!! from gdata
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT               !!! from radmsh
C Outputs:
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
C ***** DO GLOBALLY OVER SPINORS ********
        DO 5000 IUPDN1=1,NSPIN                     !!! over spinors
        DO 4000 IUPDN =1,NSPIN                     !!! over spinors
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO4000
        ISPIN=1
        ITRAN=0
	SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO4000
        ISPIN=2
        ITRAN=0
	SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO4000
        ISPIN=0
        ITRAN=2
	SIGNF=-SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO4000
        ISPIN=0
        ITRAN=1
	SIGNF=+SQRT(2.D0)
        ENDIF
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions as well as their variations
	DO JSPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)
	CALL DFIFID(ENY(0,ISORT,IKAP,IPAN,JSPIN),AFI,AFIP,AFID,AFIDP,
     &  AFIDDS,AFIDDPS,SMT(ISORT),VSPH(0,ISORT,JSPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
C  Transfere to FIH,FIJ,DELFIH,DELFIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,JSPIN)=AAH(L,ISORT,IKAP,IPAN,JSPIN)*
     &  AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,JSPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,JSPIN)=AAJ(L,ISORT,IKAP,IPAN,JSPIN)*
     &  AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,JSPIN)*AFIP(IRAD,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  Find FIny and FIny-dot radial functions as well as their variations
	IF(ISPIN.NE.0)THEN             !!! if(ispin.ne.0)
	DO IRAD=0,NRAD(ISORT)
	IF(LDLF.EQ.2)DVT(IRAD)=DPOT(IRAD,1,IATOM,ISPIN)
	IF(LDLF.EQ.1)DVT(IRAD)=(0.D0,0.D0)
	ENDDO
	DO IKAP=1,NKAP(IPAN)
	CALL DSFIFID(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  DELENY(0,IATOM,IKAP,IPAN,ISPIN,IGPTB,MY),
     &  DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),DVT(0),ILST(ISORT),NRAD(ISORT),
     &  H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
C  Transfere to FIH,FIJ,DELFIH,DELFIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	DELFIH(IRAD,L,1,IKAP)=
     &  DELAAH(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)*
     &  AFI(IRAD,L)+DELBBH(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)*
     &  AFIP(IRAD,L)+AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &  DFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIH(IRAD,L,2,IKAP)=
     &  DELAAH(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)*
     &  AFI(IRAD,L)+DELBBH(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)*
     &  AFIP(IRAD,L)+CONJG(AAH(L,ISORT,IKAP,IPAN,ISPIN))*
     &  DFI(IRAD,L)+
     &  CONJG(BBH(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
	DELFIJ(IRAD,L,1,IKAP)=
     &  DELAAJ(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)*
     &  AFI(IRAD,L)+DELBBJ(L,IATOM,IKAP,1,IPAN,ISPIN,IGPTB,MY)*
     &  AFIP(IRAD,L)+AAJ(L,ISORT,IKAP,IPAN,ISPIN)*DFI(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIJ(IRAD,L,2,IKAP)=
     &  DELAAJ(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)*
     &  AFI(IRAD,L)+DELBBJ(L,IATOM,IKAP,2,IPAN,ISPIN,IGPTB,MY)*
     &  AFIP(IRAD,L)+CONJG(AAJ(L,ISORT,IKAP,IPAN,ISPIN))*
     &  DFI(IRAD,L)+
     &  CONJG(BBJ(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
	ENDDO
	ENDDO
	ENDDO
	ENDIF                          !!! if(ispin.ne.0) 
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	IF(L2.LE.ILSV(ISORT))THEN
	DO M2=-L2,L2                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	RADMAT(1,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(2,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(3,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(4,L1,L,L2M2)=(0.D0,0.D0)
C  CHANGE ASSOCIATED WITH THE BASIS FUNCTIONS
	IF(ISPIN.NE.0)THEN             !!! if(ispin.ne.0)
	IF(SYM(L2M2,IATOM))THEN
	ISYM=LMSYM(L2M2,IATOM)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIH(IRAD,L1,2,IKAP1)*FIH(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIH(IRAD,L1,IKAP1,ISPIN))*DELFIH(IRAD,L,1,IKAP))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,L2M2)=RADMAT(1,L1,L,L2M2)+WORK2(NRAD(ISORT))
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIJ(IRAD,L1,2,IKAP1)*FIH(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIJ(IRAD,L1,IKAP1,ISPIN))*DELFIH(IRAD,L,1,IKAP))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,L2M2)=RADMAT(2,L1,L,L2M2)+WORK2(NRAD(ISORT))
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIH(IRAD,L1,2,IKAP1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIH(IRAD,L1,IKAP1,ISPIN))*DELFIJ(IRAD,L,1,IKAP))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,L2M2)=RADMAT(3,L1,L,L2M2)+WORK2(NRAD(ISORT))
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIJ(IRAD,L1,2,IKAP1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIJ(IRAD,L1,IKAP1,ISPIN))*DELFIJ(IRAD,L,1,IKAP))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,L2M2)=RADMAT(4,L1,L,L2M2)+WORK2(NRAD(ISORT))
	ENDIF
	ENDIF                          !!! if(ispin.ne.0)
C  CHANGE ASSOCIATED WITH THE PERTURBATION
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	IF(ISPIN.NE.0)DELV=DPOT(IRAD,L2M2,IATOM,ISPIN)
	IF(ITRAN.NE.0)DELV=DBXC(IRAD,L2M2,IATOM,ITRAN)
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L1,IKAP1,IUPDN1))*FIH(IRAD,L,IKAP,IUPDN)*
     &  DELV*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,L2M2)=RADMAT(1,L1,L,L2M2)+WORK2(NRAD(ISORT))*
     &  SIGNF
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	IF(ISPIN.NE.0)DELV=DPOT(IRAD,L2M2,IATOM,ISPIN)
	IF(ITRAN.NE.0)DELV=DBXC(IRAD,L2M2,IATOM,ITRAN)
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L1,IKAP1,IUPDN1))*FIH(IRAD,L,IKAP,IUPDN)*
     &  DELV*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,L2M2)=RADMAT(2,L1,L,L2M2)+WORK2(NRAD(ISORT))*
     &  SIGNF
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	IF(ISPIN.NE.0)DELV=DPOT(IRAD,L2M2,IATOM,ISPIN)
	IF(ITRAN.NE.0)DELV=DBXC(IRAD,L2M2,IATOM,ITRAN)
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L1,IKAP1,IUPDN1))*FIJ(IRAD,L,IKAP,IUPDN)*
     &  DELV*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,L2M2)=RADMAT(3,L1,L,L2M2)+WORK2(NRAD(ISORT))*
     &  SIGNF
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	IF(ISPIN.NE.0)DELV=DPOT(IRAD,L2M2,IATOM,ISPIN)
	IF(ITRAN.NE.0)DELV=DBXC(IRAD,L2M2,IATOM,ITRAN)
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L1,IKAP1,IUPDN1))*FIJ(IRAD,L,IKAP,IUPDN)*
     &  DELV*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,L2M2)=RADMAT(4,L1,L,L2M2)+WORK2(NRAD(ISORT))*
     &  SIGNF
        ENDDO                          !!! over m2
	ENDIF
        ENDDO                          !!! over l2
        ENDDO                          !!! over l
        ENDDO                          !!! over l1
C  CALCULATE NMT-POTENTIAL PARAMETER VARIATIONS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &  DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG )DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG1)DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L1M1.EQ.LM.AND.ISPIN.NE.0)THEN! add diagonal HMT-parameters
	IF(LOG1.AND.LOG)DELHHH(LM,LM,IATOM,IKAP1,IKAP)=
     &  DELHHH(LM,LM,IATOM,IKAP1,IKAP)+
     &  DHMTHH(IKAP1,IKAP,L,IATOM,ISPIN)
	IF(LOG)DELHJH(LM,LM,IATOM,IKAP1,IKAP)=
     &  DELHJH(LM,LM,IATOM,IKAP1,IKAP)+
     &  DHMTJH(IKAP1,IKAP,L,IATOM,ISPIN)
	IF(LOG1)DELHHJ(LM,LM,IATOM,IKAP1,IKAP)=
     &  DELHHJ(LM,LM,IATOM,IKAP1,IKAP)+
     &  DHMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)
	DELHJJ(LM,LM,IATOM,IKAP1,IKAP)=
     &  DELHJJ(LM,LM,IATOM,IKAP1,IKAP)+
     &  DHMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)
	ENDIF
C       IF(L1M1.EQ.LM.AND.ITRAN.NE.0)THEN! add diagonal BMT-parameters
C       IF(LOG1.AND.LOG)DELHHH(LM,LM,IATOM,IKAP1,IKAP)=
C    &  DELHHH(LM,LM,IATOM,IKAP1,IKAP)+
C    &  DORBHH(IKAP1,IKAP,L,IATOM,ITRAN)
C       IF(LOG)DELBJH(LM,LM,IATOM,IKAP1,IKAP)=
C    &  DELHJH(LM,LM,IATOM,IKAP1,IKAP)+
C    &  DORBJH(IKAP1,IKAP,L,IATOM,ITRAN)
C       IF(LOG1)DELBHJ(LM,LM,IATOM,IKAP1,IKAP)=
C    &  DELHHJ(LM,LM,IATOM,IKAP1,IKAP)+
C    &  DORBHJ(IKAP1,IKAP,L,IATOM,ITRAN)
C       DELHJJ(LM,LM,IATOM,IKAP1,IKAP)=
C    &  DELHJJ(LM,LM,IATOM,IKAP1,IKAP)+
C    &  DORBJJ(IKAP1,IKAP,L,IATOM,ITRAN)
C       ENDIF
	DO L2=ABS(L1-L),L1+L,2          !!! over l2
	IF(.NOT.(ISPIN.NE.0.AND.L2.EQ.0.AND.LDLF.EQ.2))THEN
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(LOG1.AND.LOG)DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  (0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*RADMAT(1,L1,L,L2M2)
	IF(LOG)DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  (0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &  RADMAT(2,L1,L,L2M2)*GAM(L1,ISORT)
	IF(LOG1)DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  (0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &  RADMAT(3,L1,L,L2M2)*GAM(L,ISORT)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &  DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &  (0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*RADMAT(4,L1,L,L2M2)*
     &  GAM(L1,ISORT)*GAM(L,ISORT)
	ENDIF                          !!! over m2
	ENDIF                          
        ENDDO                          !!! over l2
        ENDDO                          !!! over m
        ENDDO                          !!! over l
        ENDDO                          !!! over m1
        ENDDO                          !!! over l1
1000	CONTINUE                       !!! over ikap
2000	CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over atoms
C STORE CHANGE IN NMT-PARAMETERS
        IF(ISPIN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,41,'W')
        IF(ITRAN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,43,'W')
4000	CONTINUE                       !!! over spinors
5000	CONTINUE                       !!! over spinors
	RETURN
	END





	SUBROUTINE NMTFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,ICHN,TOPER)
************************************************************
*  Reads/writes change in the Hpar from/to the SCRFILE.    *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NKAP(NPANMAX),IS(NPAT)
        COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DELHHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
        LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER TOPER*1,SCNFILE(0:NENVMAX,-1:2,100)*60
     &   ,SCRFILE(100)*60,STATUS*3,NFILE*60
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
        COMMON /ORBS/   NORBS                                  !!! from init
        COMMON /SPIN/   NSPIN                                  !!! from init
C Inputs:
        COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
        COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
C Temporary:
        COMMON /STORE1/ DELHHH,DELHJH,DELHHJ,DELHJJ            !!! from nmtfiles
C Outputs:
        COMMON /OUT0PH/ SCNFILE                                !!! from init
        COMMON /OUT0/   SCRFILE                                !!! from init
        COMMON /WORD/   NVAL                                   !!! from nmtdata
        DATA PI/3.141592653589793D0/
C SCRATCH FILE FOR STORING CHANGE IN POTENTIAL PARAMETERS
        NRECL=0
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
        NRECL=MAX(NRECL,NVAL*LMAXH)
        ENDDO
        NFILE=SCNFILE(IGPTB,MY,ICHN)
        INQUIRE(FILE=NFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
        IF(TOPER.EQ.'D')THEN
	NRECL=4
        OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        RETURN
        ENDIF
        OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C READ/WRITE ACCORDING TO <<TOPER>>
        DO IATOM=1,NATOM              !!! over atoms
	ISORT=IS(IATOM)
        DO IKAP1=1,NKAP(IPAN)         !!! over ikap1
        DO IKAP=1,NKAP(IPAN)          !!! over ikap
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)
	IF(NORBS.EQ.2.OR.MY.EQ.0.OR.MY.EQ.2)
     &  IREC=IREC+NKAP(IPAN)**2*NATOM*(ISPIN-1)
	IF(TOPER.EQ.'R')
     &  READ(ICHN,REC=IREC)((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	IF(TOPER.EQ.'W')
     &  WRITE(ICHN,REC=IREC)((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO                          !!! over ikap
        ENDDO                          !!! over ikap1
        ENDDO                          !!! over atoms
	CLOSE(ICHN)
	RETURN
	END
