	SUBROUTINE DROFILES(IGPTB,MY,IQPNT,ICHN,TOPER)
************************************************************
*  Reads/writes/initializes induced charge density in      *
*  channels 32/33                                          *
*  TOPER='R'ead, 'W'rite, 'I'nitialize,'D'elete            *
*  TDRHO='D'rho, 'T'rho , G'rho, 'A'll                     *
*  ICHN=31/32/33 for scratch/permanent/scratch storage.    *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX)
     &   ,IBROY(0:NENVMAX,-1:2),LBROY(0:NENVMAX,-1:2)
     &   ,KEY(0:NENVMAX,-1:2),KSP(0:NENVMAX,-1:2)
     &   ,NRAD0(NSORTMAX),ILSV0(NSORTMAX)
     &   ,NITER(0:NENVMAX,-1:2)
	COMPLEX*16 
     &    DELDOCC(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMOCC(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELDHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMHUB(LIMLMB2,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &	 ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
	DIMENSION QPNT(3),QPNT0(3),SMT(NSORTMAX),H(NSORTMAX)
     &   ,CONVDRO(0:NENVMAX,-1:2),CONVDMO(0:NENVMAX,-1:2)
     &   ,R(0:NRADMAX,NSORTMAX),ROLD(0:NRADMAX,NSORTMAX)
     &   ,ADMOPT(0:NENVMAX,-1:2),ADSPIN(0:NENVMAX,-1:2)
     &   ,ADMIXB(0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
     &   ,ADMIX1(0:NENVMAX,-1:2),ADMIN (0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMSPN(0:NENVMAX,-1:2)
     &   ,ASMIN (0:NENVMAX,-1:2),ASMAX (0:NENVMAX,-1:2)
     &   ,EPS(0:NENVMAX,-1:2),GPTB(3,0:NENVMAX),GPTB0(3)
	CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100),DFILE
     &   ,DROFILE(0:NENVMAX,-1:2),DSVFILE(0:NENVMAX,-1:2)
     &   ,DPSFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
	CHARACTER TOPER*1,STATUS*3
	LOGICAL EXIST
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPFR,MODE       !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /ORBS/   NORBS                               !!! from readini
C Inputs:
        COMMON /MAGCOM/ ITERMAX,NITER,EPS,CONVDRO,CONVDMO   !!! from mixdrho
	COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB                    !!! from qvector
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
C Mixings:
        COMMON /MIXDRHO/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT       !!! from mixdrho
        COMMON /MIXDMAG/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN       !!! from mixdrho
        COMMON /MIXDBRD/LBROY,IBROY,ADMIXB,ADMIXH           !!! from mixdrob
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R                            !!! from radmsh
        COMMON /OLDMESH/NRAD0,ROLD                          !!! from drofiles
C Density:
	COMMON /DELRO/  DRHO,DMAG                           !!! from delro
C Occupancies
        COMMON /DELOCC/ DELDOCC,DELMOCC                     !!! from drhohub
        COMMON /DELHUB/ DELDHUB,DELMHUB                     !!! from drhohub
C Frequency:
	COMMON /FREQU/  OMGR                                !!! from init
C Outputs:
	COMMON /OUT0PH/ SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!from readlrt
        COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDSV            !!! from readlrt
        COMMON /WORD/   NVAL                                !!! from setup
	COMMON /UNIT/   IUN                                 !!! from readini
        IF(ICHN.NE.32)DFILE=SCNFILE(IGPTB,MY,ICHN)
        IF(ICHN.EQ.32)DFILE=DROFILE(IGPTB,MY)
        INQUIRE(FILE=DFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
        IF(TOPER.EQ.'D')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        RETURN
        ENDIF
C *** READ DATA FROM DROFILE OR SCNFILE
        IF(TOPER.EQ.'R')THEN
        IF(.NOT.EXIST)STOP'<DROFILES>: FILE MUST EXIST!'
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
        READ(ICHN)NATOM0,NSORT0,NSPIN0,(NRAD0(ISORT),ISORT=1,NSORT0),
     &  (ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3),(GPTB0(I),I=1,3),
     &  OMGR0
        READ(ICHN)((ROLD(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT)
        IF(NATOM0.NE.NATOM)STOP'<DROFILES>: # OF ATOMS MISMATCH'
        IF(NSORT0.NE.NSORT)STOP'<DROFILES>: # OF SORTS MISMATCH'
        IF(NSPIN0.NE.NSPIN)STOP'<DROFILES>: # OF SPINS MISMATCH'
        DO ISORT=1,NSORT
        IF(NRAD0(ISORT).GT.NRADMAX)STOP'<DROFILES>:: NRAD0>NRADMAX'
        IF(ILSV0(ISORT).GT.LMAXV  )STOP'<DROFILES>:: ILSV0>LMAXV  '
        ENDDO
C Read change in charge density:
        DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        READ(ICHN)((DRHO(IRAD,LM,IATOM,ISPIN),IRAD=0,NRAD0(ISORT)),
     &  LM=1,(ILSV0(ISORT)+1)**2)
        READ(ICHN)((DMAG(IRAD,LM,IATOM,ITRAN),IRAD=0,NRAD0(ISORT)),
     &  LM=1,(ILSV0(ISORT)+1)**2)
C Set zeroes for higher l's
        DO L=ILSV0(ISORT)+1,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD0(ISORT)
        DRHO(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        DMAG(IRAD,LM,IATOM,ITRAN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
C Read occupancies 
        DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
	READ(ICHN)(DELDOCC(IU,IATOM,ISPIN,IGPTB,MY),IU=1,
     &  (ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	READ(ICHN)(DELMOCC(IU,IATOM,ISPIN,IGPTB,MY),IU=1,
     &  (ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
	CLOSE(ICHN)
        ENDIF
C **** INITIALIZE CHANGE IN CHARGE DENSITY
        IF(TOPER.EQ.'I')THEN
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        DRHO(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        DMAG(IRAD,LM,IATOM,ITRAN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
C INITIALIZE CONVERGENCY CRITERIUM
        CONVDRO(IGPTB,MY)=(1.D+05,1.D+05)
        CONVDMO(IGPTB,MY)=(1.D+05,1.D+05)
	ENDIF
C **** STORE DATA IN DROFILE OR SCNFILE
        IF(TOPER.NE.'R')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
        WRITE(ICHN)NATOM,NSORT,NSPIN,(NRAD(ISORT),ISORT=1,NSORT),
     &  (ILSV(ISORT),ISORT=1,NSORT),(QPNT(I),I=1,3),
     &  (GPTB(I,IGPTB),I=1,3),OMGR,NITER(IGPTB,MY),
     &  EPS(IGPTB,MY),KEY(IGPTB,MY),KSP(IGPTB,MY),
     &  LBROY(IGPTB,MY),ADMIN(IGPTB,MY),ADMAX(IGPTB,MY),
     &  ASMIN(IGPTB,MY),ASMAX(IGPTB,MY),ADMIXB(IGPTB,MY),
     &  ADMIXH(IGPTB,MY),CONVDRO(IGPTB,MY),CONVDMO(IGPTB,MY)
        WRITE(ICHN)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT)
C Store change in charge density:
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        WRITE(ICHN)((DRHO(IRAD,LM,IATOM,ISPIN),IRAD=0,NRAD(ISORT)),
     &  LM=1,(ILSV(ISORT)+1)**2)
        WRITE(ICHN)((DMAG(IRAD,LM,IATOM,ITRAN),IRAD=0,NRAD(ISORT)),
     &  LM=1,(ILSV(ISORT)+1)**2)
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
C Store occupancies
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
        ITRAN=ISPIN
        WRITE(ICHN)(DELDHUB(IU,IATOM,ISPIN,IGPTB,MY),IU=1,
     &  (ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
        WRITE(ICHN)(DELMHUB(IU,IATOM,ISPIN,IGPTB,MY),IU=1,
     &  (ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
	CLOSE(ICHN)
	ENDIF
	END



	SUBROUTINE DPSFILES(IGPTB,MY,IQPNT,ICHN,TOPER)
************************************************************
*  Reads/writes/initializes induced charge density in      *
*  channels 34/35                                          *
*  TOPER='R'ead, 'W'rite, or 'I'nitialize                  *
*  TDRHO='D'rho, 'T'rho, 'A'll                             *
*  ICHN=31/34/35 for scratch/permanent/scratch storage.    *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX)
	COMPLEX*16 
     &    DRHOPS(0:NPLWMAX,NSPINMAX)
     &   ,DMAGPS(0:NPLWMAX,NSPINMAX)
        DIMENSION QPNT(3),QPNT0(3),GPLW(3,0:NPLWMAX)
     &    ,GPLW0(3,0:NPLWMAX),RBAS(3,3),GBAS(3,3)
     &    ,RBAS0(3,3),GBAS0(3,3),ORTH(2:3),ORTH0(2:3)
     &    ,GPTB(3,0:NENVMAX)
	CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100),DFILE
     &   ,DROFILE(0:NENVMAX,-1:2),DSVFILE(0:NENVMAX,-1:2)
     &   ,DPSFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
	CHARACTER TOPER*1,STATUS*3
	LOGICAL EXIST
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPFR,MODE       !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /QMESH/  NQPNT,QPNT                          !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB                    !!! from qvector
        COMMON /LATTICE/RBAS,GBAS                           !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
        COMMON /OLDMESH/NPLW0,GPLW0,RBAS0,GBAS0,ORTH0       !!! from dpsfiles
C Density:
	COMMON /DPSRHO/ DRHOPS,DMAGPS                       !!! from readdro
C Frequency:
	COMMON /FREQU/  OMGR                                !!! from init
C Outputs:
	COMMON /OUT0PH/ SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!from readlrt
        COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDSV            !!! from readlrt
        COMMON /WORD/   NVAL                                !!! from setup
	COMMON /UNIT/   IUN                                 !!! from readini
        IF(ICHN.NE.34)DFILE=SCNFILE(IGPTB,MY,ICHN)
        IF(ICHN.EQ.34)DFILE=DPSFILE(IGPTB,MY)
        INQUIRE(FILE=DFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
        IF(TOPER.EQ.'D')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        RETURN
        ENDIF
C *** READ DATA FROM DPSFILE OR SCNFILE
        IF(TOPER.EQ.'R')THEN
        IF(.NOT.EXIST)STOP'<DPSFILES>: FILE MUST EXIST!'
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
        IF(ICHN.EQ.34)
     &  READ(ICHN)NPLW0,((GPLW0(I,IPLW),I=1,3),IPLW=0,NPLW0),
     &  ORTH0,GBAS0,RBAS0
        IF(ICHN.NE.34)NPLW0=NPLW
        IF(NPLW0.GT.NPLWMAX)STOP'<DPSFILES>: NPLW0>NPLWMAX'
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        READ(ICHN)(DRHOPS(IPLW,ISPIN),IPLW=0,NPLW0)
        READ(ICHN)(DMAGPS(IPLW,ITRAN),IPLW=0,NPLW0)
        ENDDO                                      !!! over spins
        CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN CHARGE DENSITY
        IF(TOPER.EQ.'I')THEN
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        DO IPLW=0,NPLW
        DRHOPS(IPLW,ISPIN)=(0.D0,0.D0)
        DMAGPS(IPLW,ITRAN)=(0.D0,0.D0)
        ENDDO
        ENDDO                                      !!! over spins
        ENDIF
C **** STORE DATA IN DROFILE OR SCNFILE
        IF(TOPER.NE.'R')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
        IF(ICHN.EQ.34)
     &  WRITE(ICHN)NPLW,((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),
     &  ORTH,GBAS,RBAS
C Store change in charge density:
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        WRITE(ICHN)(DRHOPS(IPLW,ISPIN),IPLW=0,NPLW)
        WRITE(ICHN)(DMAGPS(IPLW,ITRAN),IPLW=0,NPLW)
        ENDDO                                      !!! over spins
        CLOSE(ICHN)
        ENDIF
	END
