	SUBROUTINE MIXSTN(IQPNT,ITER,KY)
**********************************************************
*  Mixes old and new partial occupancies.                *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
        PARAMETER (NSTNMAX=4*NKAPMAX*NKAPMAX)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX)
     &   ,NITER(0:NENVMAX,-1:2),LBROY(0:NENVMAX,-1:2)
     &   ,IBROY(0:NENVMAX,-1:2),KEY  (0:NENVMAX,-1:2)
     &   ,KSP  (0:NENVMAX,-1:2),MTER (0:NENVMAX,-1:2)
        DIMENSION SMT(NSORTMAX)
     &   ,ADMIN (0:NENVMAX,-1:2),ADMIX1(0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMSPN(0:NENVMAX,-1:2)
     &   ,ASMIN (0:NENVMAX,-1:2),ASMAX (0:NENVMAX,-1:2)
     &   ,ADMOPT(0:NENVMAX,-1:2),ADSPIN(0:NENVMAX,-1:2)
     &   ,ADMIXB(0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
	COMPLEX*16 
     &    STNMAT(NSTNMAX,NPAT,NSTNMAX,NPAT),AMINP,AMNEW,AMOUT
     &   ,STIMAT(NSTNMAX,NPAT,NSTNMAX,NPAT),ROOUT,ROINP,RONEW
     &   ,QINP(NSTNMAX,NPAT,NSPINMAX),QNEW(NSTNMAX,NPAT,NSPINMAX)
     &   ,QOUT(NSTNMAX,NPAT,NSPINMAX),WINP(NTERMAX,0:NENVMAX,-1:2)
     &   ,QOLD(NSTNMAX,NPAT,NSPINMAX,0:NTERMAX)
     &   ,WMIX(NTERMAX,NTERMAX,0:NENVMAX,-1:2)
	CHARACTER*10 TXTEL(NSORTMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from readini
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
        COMMON /STNCOM/ NSTN,LSTN,ISTN                       !!! from readini
        COMMON /ORBS/   NORBS                                !!! from readini
        COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from qvector
	COMMON /POTCOM/ SWZ,SMT                              !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
        COMMON /PTBCOM/ NGSHL,NGPTB                          !!! from plwptb
C Mixing:
        COMMON /MIXDRHO/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixdrho
        COMMON /MIXDMAG/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixdrho
        COMMON /MIXDBRD/LBROY,IBROY,ADMIXB,ADMIXH,MTER,WINP,WMIX!from mixbrd
C Stoner matrix:
        COMMON /STNMOM/ STNMAT,STIMAT,QINP,QOUT,QNEW         !!! from indtos
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	SAVE QOLD
	DATA PI/3.141592653589793D0/,ISCHEME/2/
	IF(MODE.EQ.4.OR.MODE.EQ.5)RETURN
	IF(LSTN.EQ.0)RETURN
C *** DO GLOBALLY OVER POLARIZATIONS
        DO 2000 MY=-1,2                          !!! over polarizations
        DO 1000 IGPTB=0,NGPTB                    !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  SET STARTING MOMENTS TO ZERO
	IF(ITER.EQ.1.AND.KY.EQ.1.AND.MODE.EQ.1)THEN
    	DO ISPIN=1,NSPIN                         !!! over spins
        DO IATOM=1,NATOM                         !!! over atoms
        ISORT=IS(IATOM)
        DO IKAP=1,NKAP(1)                        !!! over energies
        DO JKAP=1,NKAP(1)                        !!! over energies
        DO ICONF=1,4                             !!! over configurations
        ICNF=ICONF+4*(JKAP-1)+4*NKAP(1)*(IKAP-1)
        QINP(ICNF,IATOM,ISPIN)=(0.D0,0.D0)
        QNEW(ICNF,IATOM,ISPIN)=(0.D0,0.D0)
        ENDDO                                    !!! over configurations
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over atoms
	ENDDO                                    !!! over spins
	ELSEIF(ITER.EQ.1.AND.KY.EQ.1.AND.MODE.NE.1)THEN
	PRINT*,'<MIXSTN>: NOT READY!'
	ENDIF
C  DO LINEAR MIXING FOR MAGNETIC MOMENTS
	IF(ISCHEME.EQ.1.OR.LBROY(IGPTB,MY).LT.0)THEN 
        DO IATOM=1,NATOM                         !!! over atoms
        ISORT=IS(IATOM)
        DO IKAP=1,NKAP(1)                        !!! over energies
        DO JKAP=1,NKAP(1)                        !!! over energies
        DO ICONF=1,4                             !!! over configurations
        ICNF=ICONF+4*(JKAP-1)+4*NKAP(1)*(IKAP-1)
	IF(KY.EQ.2)THEN
        ROOUT=(QNEW(ICNF,IATOM,1)+QNEW(ICNF,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        ROINP=(QOLD(ICNF,IATOM,1,0)+QOLD(ICNF,IATOM,NSPIN,0))/
     &  2.D0*DBLE(NSPIN)
        RONEW=ADMOPT(IGPTB,MY)*ROOUT+(1.D0-ADMOPT(IGPTB,MY))*
     &  ROINP
        AMOUT=(QNEW(ICNF,IATOM,1)-QNEW(ICNF,IATOM,NSPIN))
        AMINP=(QOLD(ICNF,IATOM,1,0)-QOLD(ICNF,IATOM,NSPIN,0))
        AMNEW=ADSPIN(IGPTB,MY)*AMOUT+(1.D0-ADSPIN(IGPTB,MY))*
     &  AMINP
        QINP(ICNF,IATOM,1)    =(RONEW+AMNEW)/DBLE(NSPIN)
        QINP(ICNF,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
        QNEW(ICNF,IATOM,1)    =(RONEW+AMNEW)/DBLE(NSPIN)
        QNEW(ICNF,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
	ENDIF
    	DO ISPIN=1,NSPIN                         !!! over spins
	QOLD(ICNF,IATOM,ISPIN,0)=QINP(ICNF,IATOM,ISPIN)
	ENDDO                                    !!! over spins
        ENDDO                                    !!! over configurations
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over atoms
C  DO BROYDEN MIXING FOR MAGNETIC MOMENTS
	ELSEIF(ISCHEME.EQ.2.AND.LBROY(IGPTB,MY).GE.0)THEN 
        DO ISPIN=1,NSPIN                         !!! over atoms
        DO IATOM=1,NATOM                         !!! over atoms
        ISORT=IS(IATOM)
        DO IKAP=1,NKAP(1)                        !!! over energies
        DO JKAP=1,NKAP(1)                        !!! over energies
        DO ICONF=1,4                             !!! over configurations
        ICNF=ICONF+4*(JKAP-1)+4*NKAP(1)*(IKAP-1)
	IF(KY.EQ.1.AND.MTER(IGPTB,MY).EQ.0)
     &  QOLD(ICNF,IATOM,ISPIN,MTER(IGPTB,MY))=QNEW(ICNF,IATOM,ISPIN)
	IF(KY.EQ.2)THEN
        QOLD(ICNF,IATOM,ISPIN,MTER(IGPTB,MY))=QNEW(ICNF,IATOM,ISPIN)
	RONEW=WINP(MTER(IGPTB,MY),IGPTB,MY)*QOLD(ICNF,IATOM,ISPIN,0)
	DO LTER=1,MTER(IGPTB,MY)                 !!! over iterations
	RONEW=RONEW+WMIX(MTER(IGPTB,MY),LTER,IGPTB,MY)*
     &  QOLD(ICNF,IATOM,ISPIN,LTER)
	ENDDO                                    !!! over iterations
 	QINP(ICNF,IATOM,ISPIN)=RONEW
 	QNEW(ICNF,IATOM,ISPIN)=RONEW
	ENDIF
        ENDDO                                    !!! over configurations
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over energies
        ENDDO                                    !!! over atoms
	ENDDO                                    !!! over spins
	ENDIF
1000	CONTINUE                                  !!! over g-vectors
2000	CONTINUE                                  !!! over polarizations
	END
