	SUBROUTINE SNMTPAR(IPAN)
***************************************************************
*   Calculate potential parameters of the NMT-contribution    *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),LR(NSORTMAX)
	COMPLEX*16 
     &     HPARHH(LIMLMB,LIMLMB,NPAT),HPARJH(LIMLMT,LIMLMB,NPAT)
     &    ,HPARHJ(LIMLMB,LIMLMT,NPAT),HPARJJ(LIMLMT,LIMLMT,NPAT)
     &    ,HMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,WHH(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &    ,WJH(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &    ,WHJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &    ,WJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,RADMAT(4,0:LMAXT,0:LMAXT,NSYMMAX),DPAR(4,0:LMAXT)
     &    ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,WORK2(0:NRADMAX),WORK1(0:NRADMAX)
     &    ,FIH(0:NRADMAX,0:LMAXT,NKAPMAX)
     &    ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX)
	DIMENSION SMT(NSORTMAX),VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &    ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
     &    ,AFI(0:NRADMAX,0:LMAXT),AFID(0:NRADMAX,0:LMAXT)
     &    ,AFIP(0:NRADMAX,0:LMAXT),AFIDP(0:NRADMAX,0:LMAXT)
     &    ,AFIDDS(0:LMAXT),AFIDDPS(0:LMAXT),DR(0:NRADMAX,NSORTMAX)
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DIFP(0:NRADMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &    ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER*60 SCRFILE(100) 
C Controls:
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
	COMMON /RELATIV/LR                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                   !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                !!! from readini
	COMMON /INPPAR/ TNY,ENY,DNY                      !!! from potpar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS            !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                        !!! from symmlm 
C Pot.pars:
	COMMON /MTPAR/  HMTHH,HMTJH,HMTHJ,HMTJJ          !!! from lmtpar
	COMMON /INTPAR/ WHH,WJH,WHJ,WJJ                  !!! from inopar
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
C Temporary:
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from nmtpar
	COMMON /STORE2/ RADMAT,AFI,AFID,AFIP,AFIDP,FIH,FIJ!! tmp.storage
C Gaunts:
	COMMON /GAUNT/  C                                !!! from gdata
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT               !!! from radmsh
C Outputs:
	COMMON /OUT0/   SCRFILE                          !!! from nmtfile
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	OPEN(UNIT=13,FILE=SCRFILE(13),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C  *** CALCULATE MATRIX ELEMENTS OF THE FULL POTENTIAL ***
	DO 4000 ISPIN=1,NSPIN           !!! over spins
	DO 3000 IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions:
	DO IKAP=1,NKAP(IPAN)           !!! over energies
        CALL DFIFID(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,AFID,
     &  AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),VSPH(0,ISORT,ISPIN),
     &  ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &  LR(ISORT))
C  Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
        ENDDO    
        ENDDO   
        ENDDO                          !!! over energies
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	IF(L2.LE.ILSV(ISORT))THEN
	DO M2=-L2,L2                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IF(SYM(L2M2,IATOM))THEN
	ISYM=LMSYM(L2M2,IATOM)
	RADMAT(1,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(2,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(3,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(4,L1,L,ISYM)=(0.D0,0.D0)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP)*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,ISYM)=WORK2(NRAD(ISORT))
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP)*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L1,ISORT)
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L1,ISORT)*
     &  GAM(L,ISORT)
	ENDIF
        ENDDO                          !!! over m2
	ENDIF
        ENDDO                          !!! over l2
        ENDDO                          !!! over l
        ENDDO                          !!! over l1
C  SET DIFFERENCE BETWEEN REAL POTENTIAL AND POTENTIAL FOR PHI/PHIDOT
	DIFP(0)=0.D0
        DO IRAD=1,NRAD(ISORT)
	DIFP(IRAD)=R(IRAD,ISORT)*V(IRAD,1,IATOM,ISPIN)/
     &  SQRT(4.D0*PI)+VSPH(IRAD,ISORT,ISPIN)
        ENDDO
C  CALCULATE MATRIX ELEMENTS WITH THE DIFFERENCE
	DO L=0,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DPAR(1,L)=(0.D0,0.D0)
	DPAR(2,L)=(0.D0,0.D0)
	DPAR(3,L)=(0.D0,0.D0)
	DPAR(4,L)=(0.D0,0.D0)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L,IKAP1))*FIH(IRAD,L,IKAP)*
     &  DIFP(IRAD)*R(IRAD,ISORT)*DR(IRAD,ISORT)
        ENDDO                           !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(1,L)=WORK2(NRAD(ISORT))
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L,IKAP1))*FIH(IRAD,L,IKAP)*
     &  DIFP(IRAD)*R(IRAD,ISORT)*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(2,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  DIFP(IRAD)*R(IRAD,ISORT)*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(3,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  DIFP(IRAD)*R(IRAD,ISORT)*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(4,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
        ENDDO                          !!! over l
C  ******************************
C  GET TOTAL POTENTIAL PARAMETERS
C  ******************************
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG )HPARJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L1M1.EQ.LM)THEN
C  ADD SPHERICAL POTENTIAL PARAMETERS
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=
     &  HPARHH(L1M1,LM,IATOM)+HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  DPAR(1,L)+WHH(IKAP1,IKAP,L,ISORT)*EKAP(IKAP,IPAN)
	IF(LOG)HPARJH(L1M1,LM,IATOM)=
     &  HPARJH(L1M1,LM,IATOM)+HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  DPAR(2,L)+WJH(IKAP1,IKAP,L,ISORT)*EKAP(IKAP,IPAN)*
     &  GAM(L,ISORT)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=
     &  HPARHJ(L1M1,LM,IATOM)+HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  DPAR(3,L)+WHJ(IKAP1,IKAP,L,ISORT)*EKAP(IKAP,IPAN)*
     &  GAM(L,ISORT)
	HPARJJ(L1M1,LM,IATOM)=
     &  HPARJJ(L1M1,LM,IATOM)+HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  DPAR(4,L)+WJJ(IKAP1,IKAP,L,ISORT)*EKAP(IKAP,IPAN)*
     &  GAM(L,ISORT)**2
	ENDIF
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.NE.0.AND.L2.LE.ILSV(ISORT))THEN
	IF(SYM(L2M2,IATOM))THEN        !NMT terms included
	ISYM=LMSYM(L2M2,IATOM)
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=
     &  HPARHH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L2+L-L1)*
     &  C(LL2,L1M1,LM)*RADMAT(1,L1,L,ISYM)
	IF(LOG)HPARJH(L1M1,LM,IATOM)=
     &  HPARJH(L1M1,LM,IATOM)+(0.D0,1.D0)**(L2+L-L1)*
     &  C(LL2,L1M1,LM)*RADMAT(2,L1,L,ISYM)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=
     &  HPARHJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L2+L-L1)*
     &  C(LL2,L1M1,LM)*RADMAT(3,L1,L,ISYM)
	HPARJJ(L1M1,LM,IATOM)=
     &  HPARJJ(L1M1,LM,IATOM)+(0.D0,1.D0)**(L2+L-L1)*
     &  C(LL2,L1M1,LM)*RADMAT(4,L1,L,ISYM)
	ENDIF
	ENDIF                          !!! over m2
        ENDDO                          !!! over l2
        ENDDO                          !!! over m
        ENDDO                          !!! over l
        ENDDO                          !!! over m1
        ENDDO                          !!! over l1
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	WRITE(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000    CONTINUE                       !!! over ikap
2000    CONTINUE                       !!! over ikap1
3000    CONTINUE                       !!! over atoms
4000	CONTINUE                       !!! over spins
	END
