	SUBROUTINE SPLDRO(IQPNT)
**************************************************************
*  Spline old induced density into new radial mesh.          *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX)
     &   ,NRAD0(NSORTMAX),NKAP(NPANMAX),NQDIV(3)
     &   ,NITER(0:NENVMAX,-1:2)
        DIMENSION SMT(NSORTMAX),ROLD(0:NRADMAX,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),QPNT(3),QPNT0(3)
     &   ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX,2)
     &   ,DEROUT(0:NRADMAX,2),DERIN(0:NRADMAX,2),GPTB(3,0:NENVMAX)
     &   ,ROTMPR(0:NRADMAX),ROTMPI(0:NRADMAX)
        COMPLEX*16 
     &    DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
        CHARACTER TXTEL(NSORTMAX)*10
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from readini
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
        COMMON /POTCOM/ SWZ,SMT                              !!! from readini
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from readini
        COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB                     !!! from qvector
C Density:
        COMMON /DELRO/  DRHO,DMAG                            !!! from delro
C Rad.mesh:
        COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL                !!! from radmsh
        COMMON /OLDMESH/NRAD0,ROLD                           !!! from drofiles
C Outputs:
        COMMON /UNIT/   IUN                                  !!! from readini
        COMMON /TXTEL/  TXTEL                                !!! from readini
        COMMON /WORD/   NVAL                                 !!! from setup
        DATA PI/3.141592653589793D0/
        IF(MODE.NE.3)RETURN
C  *** DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS ***
	DO 2000 MY=-1,2                           !!! over polarizations
	DO 1000 IGPTB=0,NGPTB                     !!! over polarizations
	IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY
	CALL DROFILES(IGPTB,MY,IQPNT,32,'R')
C  DO OVER ATOMS AND SPINS
	DO ISPIN=1,NSPIN                          !!! over spins
	ITRAN=ISPIN
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	IF(R(IRAD,ISORT)-ROLD(NRAD0(ISORT),ISORT).GT.1.D-09)GOTO100
	ENDDO
	IRAD=NRAD(ISORT)+1
 100    NR=IRAD-1
        DO LM=1,(ILSV(ISORT)+1)**2                !!! over lm
C  SPLINE INTERPOLATION FOR THE <<DRHO>>
	DO IRAD=0,NRAD0(ISORT)
	ROTMPR(IRAD)=DREAL(DRHO(IRAD,LM,IATOM,ISPIN))
	ROTMPI(IRAD)=DIMAG(DRHO(IRAD,LM,IATOM,ISPIN))
	ENDDO
        CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRAD0(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
        CALL SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRAD0(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMAX+1,-1)
	DO IRAD=0,NR
	DRHO(IRAD,LM,IATOM,ISPIN)=DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ENDDO
	DO IRAD=NR+1,NRAD(ISORT)
	DRHO(IRAD,LM,IATOM,ISPIN)=DRHO(NR,LM,IATOM,ISPIN)
	ENDDO
C  SPLINE INTERPOLATION FOR THE <<DMAG>>
	DO IRAD=0,NRAD0(ISORT)
	ROTMPR(IRAD)=DREAL(DMAG(IRAD,LM,IATOM,ITRAN))
	ROTMPI(IRAD)=DIMAG(DMAG(IRAD,LM,IATOM,ITRAN))
	ENDDO
        CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRAD0(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
        CALL SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRAD0(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMAX+1,-1)
	DO IRAD=0,NR
	DMAG(IRAD,LM,IATOM,ITRAN)=DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ENDDO
	DO IRAD=NR+1,NRAD(ISORT)
	DMAG(IRAD,LM,IATOM,ITRAN)=DMAG(NR,LM,IATOM,ITRAN)
	ENDDO
        ENDDO                                     !!! over lm
        ENDDO                                     !!! over atoms
        ENDDO                                     !!! over spins
C  STORE SPLINE-INTERPOLATED INDUCED CHARGE DENSITY
	CALL DROFILES(IGPTB,MY,IQPNT,32,'W')
1000	CONTINUE                                  !!! over g-vectors
2000	CONTINUE                                  !!! over polarizations
	END
